<%
include "conf/system.conf";
include "conf/sync.conf";
require_once "functions/stdout.php";
require_once "functions/client.php";
include "functions/time.php";

$time_start = getmicrotime();

// check session
if (empty($HTTP_SESSION_VARS[sess_connect_sessionid])){
	include "src/style.inc";
	client_main();
	return;
}


// **************** main process ***************

if (empty($token)) $token= 0;

if ($B != "Pause"){

	// send/receive
	switch ($verb){
		case "PutListRecords":
			$boxname = "outbox";
			$action = "Posting Metadata"; $dir = "to";
			$result = client_PutListRecords($token);
			if (empty($result[identifiers])) $str_refresh = "";
			break;
		case "ListRecords":
			$boxname = "inbox";
			$action = "Harvesting Metadata"; $dir = "from";
			
			// set from date
			if (strlen($from) < 20){
				$from = oaipmh_last_datemodified("inbox");
				$fr = explode(" ",$from);
				$from = "$fr[0]T$fr[1]Z";
				if (strlen($from) < 19) $from = "0000-00-00T00:00:00Z";
			}
	
			$result = client_ListRecords($from,$token);
			if (empty($result[identifiers])) $str_refresh = "";
			$set_identifiers = "<b>Under node id:</b> $conf[sync_harvest_node] (see Options). 
				<b>From:</b> $from.<br>";
			break;
		case "ListIdentifiers":
			$boxname = "inbox";
			$action = "Harvesting Identifiers"; $dir = "from";
			$result = client_ListIdentifiers($token);
			$set_identifiers = "<b>Under node id:</b> $conf[sync_harvest_node] (see Options).<br>";
			break;
		case "ListProviders":
			$action = "Harvesting Provider Records"; $dir = "from";
			$result = client_ListProviders($token);
			break;
	}
	
	if (!empty($result[error])){
		$error_msg = "<br><b>Error message:</b> $result[error]";
	}
	
	$post_desc = "<p><font size=1>
		$set_identifiers
		<b>Successfully $action: $result[count] records, size $result[size] bytes.</b>
		<br><b>Metadata ID(s):</b> $result[identifiers] $error_msg
		</font>";
	
		
} else {
	$str_next = "Next:";
}

// ************ navigation ***********

if (is_array($result)){
	if (!empty($result[total])){
		$total = $result[total];
		$limit = $result[limit];
		$count = $result[count];
		$token = $result[token];
	} 
} else {
	
	$limit = $conf[sync_count_records];

	// total records
	$sessname = "sess_".$boxname."_stats";
	$total = $HTTP_SESSION_VARS[$sessname][FOLDER][$boxname];
}

$start = ($token - 1) * $limit +1;
$stop = $start + $limit -1;


if ($total < $stop){
	$stop = $total;
}


// ******************* header ***************

if ($stop < $total){
	$str_refresh = stdout_header_redirect(2,"/OAI-client.php?verb=$verb&from=$from&token=$token");
} else if ($verb == "PutListRecords"){
	$str_refresh = stdout_header_redirect(2,"/OAI-client.php?verb=ListRecords");
} 

%>

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<%=$str_refresh%>
<title><%=$action%> Records...</title>
<%
include "src/style.inc";
%>
</head>


<body>
<%

// display bar

$rest = $total - $stop;

$percent_width = 400;

if ($total > 0)
	$percent_elapsed = ceil($stop*$percent_width/$total);
else
	$percent_elapsed = 0;
	
$percent_rest = $percent_width - $percent_elapsed;

$bar_table = "
<table border=0 width=100% cellspacing=0 cellpadding=5>
  <tr>
    <td width=100% >
      <p align=center><b>$action $dir '$conf[sync_hub_server_name]'</b></p>
      <p align=center>$str_next $action $start - $stop of $total...</b></p>
      
<table border=0 width=$percent_width cellspacing=0 cellpadding=0>
  <tr>
    <td><img border=0 src=images/bar_left.gif></td>
    <td><img border=0 src=images/bar_blue.gif width=$percent_elapsed height=22></td>
    <td><img border=0 src=images/bar_gray.gif width=$percent_rest height=22></td>
    <td><img border=0 src=images/bar_right.gif></td>
  </tr>
</table>
      
$post_desc


      </td>
  </tr>
</table> ";

stdout_print("Progress...",$bar_table);


$time_end = getmicrotime();
$duration = $time_end- $time_start;
echo "<font color=#cccccc><small>Execution time: $duration seconds.</small></font>";

// show response
stdout_show_response($result[response]);

%>

</body>

</html>
