<%
/***************************************************************************
                          client.php  -  function related to synchronization on client
                             -------------------
    begin                : Sept, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
if (defined ('client_php')) { 
	return; 
} else { 
	define ('client_php', true); 
}

require_once "functions/stdout.php";
require_once "functions/string.php";
require_once "functions/xmlparser.php";
require_once "functions/db.php";
require_once "functions/oaipmp.php";
require_once "functions/oaipmh.php";

// Main
function client_main()
{
	global $HTTP_SESSION_VARS,$conf;
	
	string_mod_title("Export and Import");
		
	include "languages/$conf[langid]/info-export.inc";
}

// Open Socket
function client_sockopen()
{
	global $conf;

	if ($conf[sync_use_proxy]){
		$fp = fsockopen($conf[sync_proxy_server_address],$conf[sync_proxy_server_port]);
	} else {
		$fp = fsockopen($conf[sync_hub_server_name],$conf[sync_hub_server_port]);
	}
	return $fp;
}

// ****************************** EXPORT ARCHIVES *****************

// Export Metadata
function client_export_metadata($step)
{
	global $conf;
	
	string_mod_title("Export Metadata");
	
	switch ($step){
		case "1":
			include "forms/form_setdate_export_metadata.inc";
			break;
		case "2":
			client_export_metadata_action();
			break;
		default:
			include "languages/$conf[langid]/info-export_metadata.inc";
	}
}

// Dumping the metadata
function client_export_metadata_action(){
	global $start_date,$DC_PUBLISHER_ID;
	
	// get the metadata dump
	$dump = db_metadata_dump($start_date);
	
	// now
	$end_date = date("Y-m-d");
	
	// compress the metadata
	$filename = "export/metadata-$DC_PUBLISHER_ID";
	if (string_compress($dump,$filename)){
		$str_info = "$start_date--$end_date";
		$fp = fopen("$filename.txt","w");
		fputs($fp,$str_info);
		fclose($fp);
	} 
	
	return;
}

// ****************

// Download Archives
function client_download_archive()
{
	global $DC_PUBLISHER_ID;
	
	string_mod_title("Download Metadata Archive");
	
	$fname_metadata = "export/metadata-".$DC_PUBLISHER_ID.".gz";
	$fname_metadata_info = "export/metadata-".$DC_PUBLISHER_ID.".txt";
	$fname_files = "export/files-".$DC_PUBLISHER_ID.".gz";
	
	echo "To download the file, use <b>right click</b> on your mouse and then select <b>Save Target As</b>.<p>";

	if (file_exists($fname_metadata)){
		// metadata
		echo "<p><img src=/images/floppy.gif> <a href=/$fname_metadata><b>Download metadata archive</b></a> for
			".join('',file($fname_metadata_info))." (".filesize($fname_metadata)." bytes).";	
	} else {
		echo "<img src=/images/nav_arrow2.gif> Metadata is not yet archived. Please click <b>Export Metadata</b> menu and follow the steps.";
	}
	
	return;
}

// ****************************** IMPORT ARCHIVES ****************************
function client_import_metadata($step)
{
	global $conf;
	
	string_mod_title("Import Metadata Archive File to Database");
	
	switch ($step){
		case "1":
			client_import_save_file();
			break;
		case "2":
			client_import_get_records();
			break;
		case "3":
			client_import_delete_file();
		default:
			include "forms/form_import_metadata.inc";
			client_import_list();
	}
	return;
}

// save file
function client_import_save_file()
{
	global $HTTP_POST_FILES;

	$src = $HTTP_POST_FILES[archive][tmp_name];
	$dst = "import/".$HTTP_POST_FILES[archive][name];
	if (move_uploaded_file($src,$dst)){
		// delete previous log
		unlink("$dst.log");
		include "forms/form_import_metadata.inc";
		client_import_list();
	} else {
		echo "Failed to upload file.";
	}
	
}

// action
function client_import_get_records()
{
	global $metafile,$t;
	
	echo "Importing <b>$metafile</b>...";
	$gzfile = "import/$metafile";
	$maxsize = 1000000;
	
	if (file_exists($gzfile)){
		$gz = gzopen($gzfile,"r");
		while (!gzeof($gz)){
			$no++;
			$xmldata = gzread($gz,$maxsize);
			$result = oaipmp_extract_record($xmldata,"inbox");
			echo "<table border=0 class=text_small cellpadding=3>
					<tr bgcolor=$t[color_light]><td>Round:</td><td>$no</td></tr>
					<tr><td>Size:</td><td>$result[size] bytes</td></tr>
					<tr><td>Count:</td><td>$result[count] records</td></tr>
					<tr><td valign=top>Identifiers:</td><td>$result[identifiers]</td></tr>
				  </table>";
		}
		gzclose($gz);
		
		// create log
		$fp = fopen("$gzfile.log","w");
		fputs($fp,"Done");
		fclose($fp);
	} else {
		echo "<p>File <b>$metafile</b> is not found.";
	}
	return;
}


// list the uploaded files
function client_import_list()
{
	global $t;
	
	if ($dir = @opendir("import/")){
		echo "<table border=1 class=text_small>
			<tr  bgcolor=$t[color_light]><td>No</td><td>Filename</td>
			<td>Date</td><td>Size</td><td>From</td><td>Status</td><td>Action</td></tr>";
		while (($file = readdir($dir)) !== false){
			if (eregi(".gz",$file) && eregi("metadata-",$file) && !eregi(".log",$file)) {
			
				$pubid = explode("-",$file);
				$pubid2 = explode(".",$pubid[1]);
				$from = $pubid2[0];
				if (empty($from)) continue;
				
				if (file_exists("import/$file.log")){
					$status = join('',file("import/$file.log"));
				} else {
					$status = "New";
				}
			
				$no++;
				echo "<tr><td>$no</td><td><a href=/import/$file>$file</a></td><td>".date("Y-m-d h:i:s",filemtime("import/$file"))."</td>
					<td>".filesize("import/$file")."</td><td>$from</td><td>$status</td>
					<td><a href=/sync_pages.php?page=importmeta&step=2&metafile=$file>Import</a>-".
					"<a href=/sync_pages.php?page=importmeta&step=3&metafile=$file>Delete</a></td></tr>";
			}
		}
		echo "</table>";
		
		closedir($dir);
	}
}

// delete file
function client_import_delete_file()
{
	global $metafile;
	
	if (unlink("import/$metafile"))
		echo "File $metafile is deleted.";
	else 
		echo "Failed to delete $metafile.";
	
	return;
}
// ****************************** CONNECT ****************************
// Connect
function client_connect($status)
{
	global $conf, $l, $DC_PUBLISHER_ID,$DC_PUBLISHER_SERIALNO, $HTTP_SESSION_VARS;
	
	$epochTime = date("U");
	
	$providerSerialNumber = md5("$DC_PUBLISHER_SERIALNO-$epochTime");
	$providerSerialNumber = urlencode($providerSerialNumber);
	
	$REQUEST = "verb=Connect&providerId=$DC_PUBLISHER_ID".
				"&providerSerialNumber=$providerSerialNumber"
				."&epochTime=$epochTime";
	
	
	$title = "Connecting to Target Server: $conf[sync_hub_server_name]";
	
	if ($status == "start"){
		$html = stdout_header_redirect(2,"/sync_pages.php?page=connect");
		$html .= "<h3>$title</h3>";
		
		$msg = "Trying connection to <b>Target Server ($conf[sync_hub_server_name])</b>.";
		
		if ($conf[sync_use_proxy]) 
			$msg .= "<br>Using proxy: <b>$conf[sync_proxy_server_address]:$conf[sync_proxy_server_port]</b>.";
		
		$msg .= "<br>Please wait... ";
		
		echo $html;
		stdout_error($msg);
		
	} else {

		$fp = client_sockopen();
		if (!$fp){
			$errmsg = "<b>$l[time_out]</b>";
			client_print_information($title,$errmsg);
		} else {
			$URI = "http://$conf[sync_hub_server_name]/$conf[sync_oai_script]?$REQUEST";
			fputs($fp,"GET $URI HTTP/1.0\r\n\r\n");

			$start = 0;
			
			while (!feof($fp)){
				$buffer = fgets($fp,"4028");
				if ($start) {
					$response .= $buffer;
				}
				if ($buffer == "\r\n") $start = 1;
			}
			fclose($fp);
						
			// get XML values
			$xml_response = readXML($response);
			// get connection status
			$status = client_connection_status($xml_response);	
			
			$errmsg = "<b>Request:</b><br> <i>".wordwrap($REQUEST,50,"<br>",1)." </i><p>";
			
			
			// show page
			if ($status){
				$errmsg .= "<b>$l[connected]</b>
					<br>sessionId = ".$HTTP_SESSION_VARS[sess_connect_sessionid].
					"<br>responseDate = ".$HTTP_SESSION_VARS[sess_connect_date].
					"<br>providerId = ".$xml_response["CONNECT.PROVIDERID"][0].
					"<br>providerNetwork = ".$xml_response["CONNECT.PROVIDERNETWORK"][0];
			} else {
				$errmsg .= "<b>$l[failed]</b>
					<br>Error code: <b>".$xml_response["ERROR.CODE"][0]
					."</b><br>Message from $conf[sync_hub_server_name]: <i>".$xml_response["ERROR"][0]."</i>";	
			}
			client_print_information($title,$errmsg);
			
			// show response
			stdout_show_response($response);
		}
	}
	
	return $status;
}

// Get connection status
function client_connection_status($xml)
{
	global $HTTP_SESSION_VARS;
	
	if (is_array($xml["CONNECT.SESSIONID"])){
		session_register("sess_connect_sessionid","sess_connect_date");
		$HTTP_SESSION_VARS[sess_connect_sessionid] = $xml["CONNECT.SESSIONID"][0];
		$HTTP_SESSION_VARS[sess_connect_date] = $xml["RESPONSEDATE"][0];
		return 1;
	} else {
		return 0;
	}
}

// Print status
function client_print_status()
{
	global $HTTP_SESSION_VARS, $conf;
	
	if (empty($HTTP_SESSION_VARS[sess_connect_sessionid])){
		$img = "<img src=/images/disconnected.gif>";
		$stat = "<font color=#ff0000><b>Disconnected</b></font> from ";
	} else {
		$img = "<img src=/images/connected.gif>";
		$stat = "<font color=#000fff><b>Connected</b></font> to ";
	}
	echo "<br><table border=0 cellspacing=0 cellpadding=2>
		<tr>
			<td valign=top>$img</td>
			<td><font size=1>Status:<br>$stat the <b><a href=http://$conf[server_hub] target=_top>Hub Server</a></b></font></td>
		</tr>

		</table>";

	
	return;
}

// Disconnect
function client_disconnect()
{
	global $HTTP_SESSION_VARS;
	
	$HTTP_SESSION_VARS[sess_connect_sessionid] = "";
	
	// For this moment, Disconnect doesn't send any request to the server.
	
	$title = "Connecting to HUB Server";
	$msg = "<b>DISCONNECTED...</b>
			<br>You have been disconnected from the Hub Server.";
	client_print_information($title,$msg);
	return;
}


// ****************************  Send and Receive ********************************

// This function will check the Outbox, and send the records in the outbox.
// Outbox will consist of new or updated metadata and membership records.

// Send metadata records by records
function client_send_receive($verb)
{
	global $HTTP_SESSION_VARS;
	
	// verb
	switch ($verb){
		case "PutListRecords":
			$boxname = "outbox";
			break;
		case "ListRecords":
			$boxname = "inbox";
			break;
		default:
			$boxname = "outbox";
	}

	
	$sessname = "sess_".$boxname."_stats";
	
	// check session
	if (!client_check_session()){
		return;
	}
	
	// read box statistics
	$stats = client_box_stats($boxname);
	
	// save into session
	session_register($sessname);
	$HTTP_SESSION_VARS[$sessname] = $stats;
	
	if ($boxname == "inbox")
		$page = "ListIdentifiers";
	else
		$page = "options";
	
	if ($HTTP_SESSION_VARS[$sessname][FOLDER][$boxname] < 1){

		if ($HTTP_SESSION_VARS[$sessname][FOLDER][sent] < 1){
			//echo stdout_header_redirect(1,"/sync_pages.php?page=$page&select=analyze");
			$str_start= "<p><b>Status:</b> $boxname is empty.</p>
				>> <b><a href=/sync_pages.php?page=$page&select=analyze>Next, updating $boxname headers</a>.</b>
				<br>>> Or, <b><a href=/OAI-client.php?verb=ListRecords>Harvesting Metadata</a>.</b>";
		} else {
			echo stdout_header_redirect(1,"/OAI-client.php?verb=ListRecords");
			$str_start= "<p><b>Status:</b> $boxname is empty.</p>
				>> <b><a href=/OAI-client.php?verb=ListRecords>Next, harvesting metadata</a>.</b>
				";
		}
		
	} else {
		echo stdout_header_redirect(2,"/OAI-client.php?verb=$verb");
		$str_start = "<p>Synchronization will be started in 2 seconds.</p><h3>Please wait...</h3>";
	}
	
	include "src/style.inc";
	string_mod_title("Send and Receive Metadata");
	
	if (is_array($HTTP_SESSION_VARS[$sessname])){
		$folder = $HTTP_SESSION_VARS[$sessname][FOLDER][$boxname];
		$sent = $HTTP_SESSION_VARS[$sessname][FOLDER][sent];
		$received = $HTTP_SESSION_VARS[$sessname][FOLDER][received];
		
		if (empty($folder)) $folder = "0";
		if (empty($sent)) $sent = "0";
		if (empty($received)) $received = "0";
		
		if ($boxname == "outbox")  {
			$process = "Sent"; 
			$processed = $sent;
		} else {
			$process = "Received"; 
			$processed = $received;
		}
		
		echo "<table border=0 cellspacing=0 cellpadding=5><tr>
			<td><b>Analyzing ".ucfirst($boxname)."</b>
			<p>
			<table width=160 border=0 cellspacing=0 cellpadding=0>
			<tr>
				<td><li>".ucfirst($boxname).": </td><td align=right>$folder items.</td>
			</tr>
			<tr>
				<td><li>$process: </td><td align=right>$processed items.</td>
			</tr>
			</table>
			$str_start
			</td></tr></table>";
	} else {
		echo "Outbox is empty.";
	}
	//
}

// check session
function client_check_session()
{
	global $HTTP_SESSION_VARS, $conf;
	
	if (empty($HTTP_SESSION_VARS[sess_connect_sessionid])){
		string_mod_title("Connection Status");
		include "src/style.inc";
		include "languages/$conf[langid]/info-export.inc";
		return 0;
	} else {
		return 1;
	}
}

// ***************** get  response  elements ****************
// get element response
function client_get_response_elements($fp,$verb)
{
		while (!feof($fp)){
			$line = fgets($fp,4000);
			
			// get response
			if ($response_start) $response .= $line;
			if (ereg("Content-Type: ",$line)) $response_start = 1;
			if (ereg("<error code=",$line)) $err_element = $line;
			// get put response
			if (ereg("<$verb>",$line)) $start = 1;
			if ($start) $put_response .= $line;
			if (ereg("</$verb>",$line)){
				$xmldata = $put_response;
			}
		}
		$res[all] = $response;
		
		// error
		if (empty($xmldata)){
			$res[error] = $err_element;
			return $res;
		}
		
		if (empty($xmldata)) {
			//echo "Error: unable to read response format. Response: $response";
			return $response;
		} else {
			$res[xmldata] = $xmldata;
			return $res;
		}
}

// **************************** PutListRecords *********************

// Posting metadata
function client_PutListRecords($resumptionToken)
{
	global $HTTP_SESSION_VARS,$conf;
	
	$title = "Send Metadata List Records";
	
	// construct request
	$request = oaipmp_request_PutListRecords($resumptionToken);
	
	//**********
	$fp = client_sockopen();
		
	if (!$fp){
		$errmsg = "<b>$l[time_out]</b>";
		client_print_information($title,$errmsg);
		return;
	} else {
		fputs($fp,$request[HEADER] . $request[DATA]);
		$response = client_get_response_elements($fp,"PutListRecords");
	}
	fclose($fp);
	
	// results
	if (!empty($response[xmldata])){
		$xml = readXML($response[xmldata]);	
		$result[identifiers] = $xml[IDENTIFIERS][0];
		$result[size] = $xml[SIZE][0];
		$result[count] = $xml[COUNTRECORDS][0];
		$result[total] = $HTTP_SESSION_VARS[sess_outbox_stats][FOLDER][outbox];
		$result[token] = $resumptionToken + 1;
		$result[limit] = $conf[sync_count_records];
		
		if (empty($result[count])) $result[count] = "0";
		
		if (!empty($xml[ERROR][0])) $result[error] = "<br>Warning: ".$xml[ERROR][0];
	
		// response
		$result[response] = $response[all];
		
		// update box
		client_box_update($xml[IDENTIFIERS][0],"outbox");
		
		return $result;
	} else {
		return $response;
	}
}



// ****************************** ListIdentifiers ********

function client_ListIdentifiers($token)
{
	global $HTTP_SESSION_VARS, $conf;
	
	// construct request
	$request = oaipmh_request_ListIdentifiers($token);
	
	// open connection
	$fp = client_sockopen();
		
	if (!$fp){
		$errmsg = "<b>$l[time_out]</b>";
		client_print_information($title,$errmsg);
		return;
	} else {
		fputs($fp,$request);
		$response =  client_get_response_elements($fp,"ListIdentifiers");
	}
	fclose($fp);
	
	// results
	
	if (!empty($response[xmldata])){
		$result = client_update_inbox($response[xmldata]);
	} else {
		$result[error] = $response[error];
		$result[count] = 0;
		$result[size] = 0;
	}
	
	// response
	$result[response] = $response[all];
	
	return $result;
}

// update inbox
function client_update_inbox($xmldata)
{
	$xml = readXML($xmldata);
	
	$result[size] = strlen($xmldata);
	$count = 0;
	
	// identifiers
	while (list($key,$val) = each ($xml["HEADER.IDENTIFIER"])){
		$count++;
		
		$identifier = $val;
		$datestamp = $xml["HEADER.DATESTAMP"][$key];
		$setspec = $xml["HEADER.SETSPEC"][$key];
		
		// check existence
		$strcheck = "SELECT DATEMODIFIED FROM inbox 
								WHERE 
									IDENTIFIER = '$identifier'";
		$dbcheck = mysql_query($strcheck);
		if ($dbcheck){
			if (mysql_num_rows($dbcheck)>0){
				$mydate = mysql_result($dbcheck,"DATEMODIFIED",0);
				if ($mydate == $datestamp) {
					continue; 
				}
				// update
				$strsql = "UPDATE inbox 
							SET 
								STATUS = 'new',
								FOLDER = 'inbox',
								DATEMODIFIED = '$datestamp'
							WHERE IDENTIFIER = '$identifier'";
				$status = "updated";
								
			} else {
				// insert into inbox
				$strsql = "INSERT INTO inbox 
						(
							TYPE,
							IDENTIFIER,
							STATUS,
							FOLDER,
							DATEMODIFIED
						)
					VALUES 
						(
							'metadata',
							'$identifier',
							'new',
							'inbox',
							'$datestamp'
						)";
				$status = "new";
				
			}
		}
		
		$dbres = mysql_query($strsql);
		if ($dbres){
			$result[identifiers] .= "$identifier ($status); ";
		} else {
			echo mysql_error();
		}
		
	}	
	
	if (empty($result[identifiers])) $result[identifiers] = "Identifiers are uptodated.";
	
	// total identifiers
	$result[total] = $xml["RESUMPTIONTOKEN.COMPLETELISTSIZE"][0];
	$result[count] = $count;
	$result[token] = $xml["RESUMPTIONTOKEN"][0];
	
	return $result;
}

// received inbox
function client_update_box_status($identifier,$datestamp,$status,$box)
{
	
	if ($box == "inbox") 
		$folder = "received";
	else if ($box == "outbox")
		$folder = "sent";
	
	switch ($status){
		case "insert":
			$strsql = "INSERT INTO $box 
						(
							TYPE,
							IDENTIFIER,
							STATUS,
							FOLDER,
							DATEMODIFIED
						)
					VALUES 
						(
							'metadata',
							'$identifier',
							'success',
							'$box',
							'$datestamp'
						)";
			break;
		case "new":
			$strsql = "INSERT INTO $box 
						(
							TYPE,
							IDENTIFIER,
							STATUS,
							FOLDER,
							DATEMODIFIED
						)
					VALUES 
						(
							'metadata',
							'$identifier',
							'success',
							'$folder',
							'$datestamp'
						)";
			break;
		case "need_update":
			$strsql = "UPDATE $box 
							SET 
								STATUS = '$status',
								FOLDER = '$box',
								DATEMODIFIED = '$datestamp'
							WHERE IDENTIFIER = '$identifier'";
			break;
			
		default:
			$strsql = "UPDATE $box 
							SET 
								STATUS = 'success',
								FOLDER = '$folder',
								DATEMODIFIED = '$datestamp'
							WHERE IDENTIFIER = '$identifier'";
		
	}
	
	$dbres = mysql_query($strsql);
	if (!$dbres) echo "<br>client_update_box_status(): ".mysql_error();
	return;
}


// ****************************** ListRecords **********************
function client_ListRecords($from,$token)
{
	global $HTTP_SESSION_VARS, $conf;
	
	
	// construct request
	$request = oaipmh_request_ListRecords($from,$token);
	
	// open connection
	$fp = client_sockopen();
		
	if (!$fp){
		$errmsg = "<b>$l[time_out]</b>";
		client_print_information($title,$errmsg);
	} else {
		fputs($fp,$request);
		$response =  client_get_response_elements($fp,"ListRecords");
		fclose($fp);
	}
	


	// results
	
	if (!empty($response[xmldata])){
		$result = oaipmp_extract_record($response[xmldata],"inbox");
		$result[limit] = $conf[sync_count_records];
	} else {
		$result[error] = $response[error];
		$result[count] = 0;
		$result[total] = 0;
		$result[size] = 0;
		$result[token] = 0;
		$result[limit] = 0;
	}
		
	// response
	$result[response] = $response[all];

	return $result;
}

// ****************************** ListProviders ********************
function client_ListProviders($token)
{
	global $HTTP_SESSION_VARS, $conf;
	
	
	// construct request
	$request = oaipmh_request_ListProviders($token);
	
	// open connection
	$fp = client_sockopen();
		
	if (!$fp){
		$errmsg = "<b>$l[time_out]</b>";
		client_print_information($title,$errmsg);
	} else {
		fputs($fp,$request);
		$response =  client_get_response_elements($fp,"ListProviders");
	}
	fclose($fp);


	// results
	
	if (!empty($response[xmldata])){
		$result = oaipmh_extract_providers($response[xmldata]);
		$result[limit] = $conf[sync_count_records];
	} else {
		$result[error] = $response[error];
		$result[count] = 0;
		$result[total] = 0;
		$result[size] = 0;
		$result[token] = 0;
		$result[limit] = 0;
	}
		
	// response
	$result[response] = $response[all];

	return $result;	
	
}

// ****************************** Options *************

// Options
function client_options()
{
	global $select,$conf,$frm,$B,$t;
	
	string_mod_title("Options");
	
	if (empty($select)){
		include "src/style.inc";
		include "languages/$conf[langid]/info-options.inc";
	} else {
		switch ($select){
			case "analyze":
				echo stdout_header_redirect(1,"/sync_pages.php?page=PutListRecords");
				include "src/style.inc";
				echo "<b>Analyzing Metadata Table</b>";
				echo "<p>Analyzing metadata table for Outbox (posting):<br>";
				client_generate_outbox("metadata");
				
				//echo "<p>Analyzing user table:</p>";
				//client_generate_outbox("user");
				
				break;
			
			case "options":
				$count = $conf[sync_count_records];
				$show = $conf[sync_show_response];
				$proxy = $conf[sync_use_proxy];

				$cproxy[$proxy] = "checked";
				$selected[$count] = "selected";
				$checked[$show] = "checked";
				
				include "src/style.inc";
				include "languages/$conf[langid]/form-options.inc";
				break;
			case "save":
				
				include "src/style.inc";
				
				// button selection
				switch ($B){
					case "Use Default":
						$default = TRUE;
					case "Save Changes":
						include "src/sync_conf.inc";
						break;
					case "Reset Inbox":
						client_reset_box("inbox");
						return;
					case "Reset Outbox":
						client_reset_box("outbox");
						return;
				}			
				break;
			default:
				break;
		}
	
	}
}

// reset inbox
function client_reset_box($box)
{
	$strsql = "DELETE FROM $box";
	$dbres = mysql_query($strsql);
	if ($dbres){
		echo "Successfully initializing $box.";
	} else {
		echo "Error initializing $box. <br>".mysql_error();
	}
	return;
}

// ***********************************************************************

// generate outbox from metadata table
function client_generate_outbox($type)
{
	global $DC_PUBLISHER_ID;
	
	switch($type){
		case "metadata":	
			$strsql = "SELECT IDENTIFIER, DATEMODIFIED, TYPE , STATUS
						FROM metadata 
						WHERE 
							PUBLISHER = '$DC_PUBLISHER_ID' AND
							MODE LIKE '%r-'
							";
			break;
		case "user":
			$strsql = "SELECT EMAIL as IDENTIFIER, DATESTAMP as DATEMODIFIED FROM user";
			break;
		default:
	}
	
	// read the outbox
	$strsql2 = "SELECT * FROM outbox WHERE TYPE = '$type'";
	$dbres2 = mysql_query($strsql2);
	if ($dbres2){
		while ($row2 = mysql_fetch_array($dbres2)){
			$myid = $row2[IDENTIFIER];
			$mystatus = $row2[STATUS];
			$myfolder = $row2[FOLDER];
			$myset = $row2[SETSPEC];
			
			$outbox[$myid][STATUS] = $mystatus;
			$outbox[$myid][FOLDER] = $myfolder;
			$outbox[$myid][DATEMODIFIED] = $row2[DATEMODIFIED];
			
			$count_status[$mystatus]++;
			$count_folder[$myfolder]++;
			$count_set[$myset]++;
		}
	} else {
		stdout_error("client_generate_outbox(): ".mysql_error());
		return 0;
	}
	
	// read the source table and import summary to outbox
	
	$dbres = mysql_query($strsql);
	if ($dbres){
		while ($row = mysql_fetch_array($dbres)){
			$myid = $row[IDENTIFIER];
			$mydate = $row[DATEMODIFIED];
			$mystatus = $row[STATUS];
			
			if ($type == "user"){
				$myset = "user";
			} else {
				$myset = $row[TYPE];
			}
					
			if (empty($outbox[$myid][DATEMODIFIED])){
				// add into the outbox
				client_outbox_add($type, $myid, $mystatus, "outbox", $mydate);
			} else {
				// check
				
			}
		}
		
		if (!is_array($count_status)) return;
		
		// echo summary
		echo "<br>Status:";
		while (list($key,$val) = each($count_status)){
			echo "<li>$key = $val";
		}
		echo "<br>Folder:";
		while (list($key,$val) = each($count_folder)){
			echo "<li>$key = $val";
		}
		echo "<br>Set:";
		while (list($key,$val) = each($count_set)){
			echo "<li>$key = $val";
		}
	} else {
		stdout_error("client_generate_outbox(): ".mysql_error());
		return 0;
	}
}

// add into outbox or remotebox
function client_outbox_add($type,$identifier,$status,$folder,$datemodified)
{
	$strsql = "INSERT INTO outbox (TYPE,IDENTIFIER,STATUS,FOLDER,DATEMODIFIED)
					VALUES ('$type','$identifier','$status','$folder','$datemodified')";
	$dbres = mysql_query($strsql);
	if ($dbres){
		echo "<br>$identifier .. ok.";
	} else {
		stdout_error("client_outbox_add(): ".mysql_error()."<br>$strsql");
		return 0;
	}
}

// Update outbox
function client_box_update($identifiers,$box)
{

	if ($box == "inbox")
		$folder = "received";
	else if ($box == "outbox")
		$folder = "sent";

	$arr_identifiers = explode("; ",$identifiers);
	while (list($key,$val) = each($arr_identifiers)){
		if (ereg(" ",$val)){
			$idar = explode(" ",$val);
			$id = $idar[0];
		} else {
			$id = $val;
		}
		
		$strsql = "UPDATE $box SET
						FOLDER = '$folder',
						STATUS = 'success'
					WHERE IDENTIFIER = '$id'";
					
		$dbres = mysql_query($strsql);
		if ($dbres){

		} else {
			stdout_error("client_box_update(): ".mysql_error());
			return 0;
		}
	}
}

// statistics for outbox
function client_box_stats($boxname)
{
	// total box
	$strsql1 = "SELECT count(*) as TOTAL FROM $boxname";
	$dbres = mysql_query($strsql1);
	if ($dbres){
		$total = mysql_result($dbres,0,"TOTAL");
		$box_stats[TOTAL] = $total;
	}
	// total per folder
	$strsql2 = "SELECT FOLDER,count(FOLDER) as TOTAL FROM $boxname 
					WHERE STATUS <> 'deleted' 
					GROUP BY FOLDER";
	$dbres = mysql_query($strsql2);
	if ($dbres){
		while ($row = mysql_fetch_array($dbres)){
			$folder = $row[FOLDER];
			$total2 = $row[TOTAL];
			$box_stats[FOLDER][$folder] = $total2;
		}
	}

	return $box_stats;
}



// ***********************************************************************

// Print information
function client_print_information($title,$msg)
{
	string_html_header("Main");
	echo "<h3>$title</h3>";
	stdout_error($msg);
	return;
}
%>