<%
/***************************************************************************
                          form.php  -  function related to form processing
                             -------------------
    begin                : June 14, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 

if (defined ('form_php')) { 
	return; 
} else { 
	define ('form_php', true); 
}

require_once "functions/user.php";
require_once "functions/string.php";

// Function to print the form values
function form_print_array($frm)
{
	echo "<pre>";
	print_r ($frm);
	echo "</pre>";

	return;
}

// FUnction to check the form entries
function form_is_valid(&$frm,$frm_validation_file)
{
	global $frmred, $errmsg, $e;
	
	// init
	$valid = TRUE;
	$valid2 = TRUE;

	if (isset($frm_validation_file) && file_exists($frm_validation_file)){
		include $frm_validation_file;
		$frm_required_fields = frm_required();
	}	

	if (is_array($frm_required_fields)){
		while(list($key,$val) = each($frm_required_fields))
		{
			if (empty($frm[$val])) {
				$valid2 = FALSE;
				$frmred[$val] = "color=#ff0000";
			}
		}
	}
	
	if (!$valid2) {
		$errmsg .= "<p>".$e[form_invalid];
		if ($valid) $valid = $valid2;
	} elseif (!$valid){
		$errmsg .= "<p>".$e[form_invalid];
	}
	return $valid;
}

// Function to ask form completion to the user
function form_completion($frm, $form_file)
{
	global $conf, $frmred, $errmsg,$l,$t;
	
	// your entry is not valid, so please complete it now
	include $form_file;
	
	return;
}

// Function to generate access_mode
function form_access_mode($mode)
{
	$f_mode = form_access_mode_slash($mode["or"]);
	$f_mode .= form_access_mode_slash($mode[ow])."-";
	$f_mode .= form_access_mode_slash($mode[gr]);
	$f_mode .= form_access_mode_slash($mode[gw])."-";
	$f_mode .= form_access_mode_slash($mode[pr]);
	$f_mode .= form_access_mode_slash($mode[pw]);
	
	return $f_mode;
}

// 
function form_access_mode_slash($acmod)
{
	if (empty($acmod))	
		return "-";
	else
		return $acmod;
}

// FUnction to display folder edit form
function form_folder_edit($folderid, $side, $parent_path)
{
	global $e,$t,$l,$b,$HTTP_SESSION_VARS;
	
	// auth
	if (!explorer_folder_iswrite("folder",$folderid)){
		echo $e[access_denied];
		return FALSE;
	}

	if (!empty($folderid) && ($b == "edit")){
		
		$folder_info = explorer_folder_info($folderid);
		$folder_edit = $folder_info[NAME];
		
		$checked = form_get_mode($folder_info[MODE]);
		
		$selected["$folder_info[WGID]"] = "selected";
		
		$btn_delete = "<input type=submit name=folder_delete value=$l[del] 
							style=\"font-family: Arial; font-size: 8pt\">";
							
		$ftype = $folder_info[TYPE];
		
	} else {
		$checked["or"] = "checked";
		$checked[gr] = "checked";
		$checked[pr] = "checked";
		$checked[ow] = "checked";
		$folder_edit = $_POST[folder_name];
		$ftype = $_POST[folder_type];
	}
	
	
	// type	
	if (empty($ftype)) $ftype = "folder";
	$checked[$ftype] = "checked";
	
	$html_type = "
		<table border=0 cellspacing=0 cellpadding=0 width=100% >
		<tr>
			<td>
				<input type=radio name=folder_type value=folder $checked[folder]><img src=/images/dir.gif> <font size=1>Folder</font> 
		   	</td>
		   	<td></td>
		</tr>
		<tr>
		   	<td>
		   		<input type=radio name=folder_type value=organization $checked[organization]><img src=/images/homesml.gif> <font size=1>$l[organization]</font>
			</td>
			<td>
		   		<input type=radio name=folder_type value=personal $checked[personal]><img src=/images/person.gif> <font size=1>$l[personal]</font>
			</td>
		</tr>
	  </table> ";
	  
	
	// workgroup
	$select_workgroup = form_select_workgroup($HTTP_SESSION_VARS[sess_email], $selected);
	
	if ($HTTP_SESSION_VARS[sess_explorer_pane] == 1)
		$frm_width = 40;
	else
		$frm_width = 20;
	
	$html = "
	
		<input type=hidden name=folder_parent_path value=\"$parent_path\">
	
	  <table border=0 width=100% cellspacing=0 cellpadding=4 bgcolor=$t[color_light]>
		<tr><td>
		<table border=0 cellspacing=0 cellpadding=0 >
			<tr>
				<td>
					
						A. <b><a href=/office.php?m=upload&a=$folderid&b=&w=$side>$l[upload] $l[file]</a>,</b> or<br>
						B. <b>".ucfirst($b)." Folder:</b>
					
				</td>
			</tr>
		</table>
		<table border=0 cellspacing=0 cellpadding=0 >
	   		<tr>
	   			<td nowrap align=right><font size=1><b>$l[name]:</b></font></td>
	   			<td>&nbsp;</td>
	   			<td><font size=1><input type=text name=folder_name size=$frm_width 
	   				style=\"font-family: Arial; font-size: 8pt\" value=\"".str_replace(" ","_",$folder_edit)."\"> 
	   			</font></td>
	   		</tr>
	   		<tr>
	   			<td align=right valign=top><font size=1><b>Type:</b></font></td>
	   			<td></td>
	   			<td>$html_type</td>
	   		</tr>
	   		<tr>
	   			<td nowrap align=right><font size=1><b>$l[access_mode]:</b></font></td>
	   			<td></td>
	   			<td>
	   				<table>
	   					<tr>
	   						<td><input type=checkbox name=mode[or] value=r $checked[or]>r<input type=checkbox name=mode[ow] value=w $checked[ow]>w -</td>
	   						<td><input type=checkbox name=mode[gr] value=r $checked[gr]>r<input type=checkbox name=mode[gw] value=w $checked[gw]>w -</td>
	   						<td><input type=checkbox name=mode[pr] value=r $checked[pr]>r<input type=checkbox name=mode[pw] value=w $checked[pw]>w
	   							</td>
	   					</tr>
	   					<tr>
	   						<td align=center><font size=1>owner</font></td>
	   						<td align=center><font size=1>workgroup</font></td>
	   						<td align=center><font size=1>public</font></td>
	   					</tr>
	   				</table>
	   		</tr>
	   		<tr>
	   			<td align=right><font size=1 $wgcolor><b>$l[workgroup]:</b></font></td>
	   			<td></td>
	   			<td><font size=1>$select_workgroup</font> 
	   			<input type=submit value=Go style=\"font-family: Arial; font-size: 8pt\">
	   			$btn_delete</td>
	   		</tr>
	   </table>
	   </td></tr>
	   </table>
	   ";
	 
	 return $html;
	 
}

// FUnction to display metadata edit form
function form_metadata_edit($id, $side)
{
	global $e,$t,$l,$b,$HTTP_SESSION_VARS;
	
	// auth
	if (!explorer_folder_iswrite("metadata",$id)){
		echo $e[access_denied];
		return FALSE;
	}

	if (!empty($id) && ($b == "edit")){
		
		$meta_info = metadata_info($id);
		$meta_data = metadata_read_xml($id);
		$title = $meta_data[TITLE][0];
		
		$checked = form_get_mode($meta_info[MODE]);
		
		$selected["$meta_info[WGID]"] = "selected";
		
		$btn_delete = "<input type=submit name=folder_delete value=$l[del] 
							style=\"font-family: Arial; font-size: 8pt\">";
		
	} else {
		$checked["or"] = "checked";
		$checked[gr] = "checked";
		$checked[pr] = "checked";
		$checked[ow] = "checked";
	}
	  
	
	// workgroup
	$select_workgroup = form_select_workgroup($HTTP_SESSION_VARS[sess_email], $selected);
	
	
	$html = "
		
		<input type=hidden name=id value=$id>
		
	  <table border=0 width=100% cellspacing=0 cellpadding=4 bgcolor=$t[color_light]>
		<tr><td>
		<table border=0 cellspacing=0 cellpadding=0 >
			<tr>
				<td>
					
						A. <b><a href=/office.php?m=upload&step=2&type=$meta_info[SCHEMA]&id=$id>$l[edit] Metadata</a>,</b> or<br>
						B. <b>".ucfirst($b)." Profile Metadata:</b>
					
				</td>
			</tr>
		</table>
		<table border=0 cellspacing=0 cellpadding=0 >
	   		<tr>
	   			<td nowrap align=right valign=top><font size=1><b>$l[title]:</b></font></td>
	   			<td>&nbsp;</td>
	   			<td><font size=1>$title ($id)</b>
	   			</font></td>
	   		</tr>
	   		<tr>
	   			<td nowrap align=right><font size=1><b>$l[access_mode]:</b></font></td>
	   			<td></td>
	   			<td>
	   				<table>
	   					<tr>
	   						<td><input type=checkbox name=mode[or] value=r $checked[or]>r<input type=checkbox name=mode[ow] value=w $checked[ow]>w -</td>
	   						<td><input type=checkbox name=mode[gr] value=r $checked[gr]>r<input type=checkbox name=mode[gw] value=w $checked[gw]>w -</td>
	   						<td><input type=checkbox name=mode[pr] value=r $checked[pr]>r<input type=checkbox name=mode[pw] value=w $checked[pw]>w
	   							</td>
	   					</tr>
	   					<tr>
	   						<td align=center><font size=1>owner</font></td>
	   						<td align=center><font size=1>workgroup</font></td>
	   						<td align=center><font size=1>public</font></td>
	   					</tr>
	   				</table>
	   		</tr>
	   		<tr>
	   			<td align=right><font size=1 $wgcolor><b>$l[workgroup]:</b></font></td>
	   			<td></td>
	   			<td><font size=1>$select_workgroup</font>
	   			<input type=submit value=Go style=\"font-family: Arial; font-size: 8pt\">
	   			$btn_delete</td>
	   		</tr>
	   </table>
	   </td></tr>
	   </table>
	   ";
	 
	 return $html;
	 
}

// Mode
function form_get_mode($mode)
{
	if (substr($mode,0,1) == "r") $checked["or"] = "checked";
	if (substr($mode,1,1) == "w") $checked[ow] = "checked";
	if (substr($mode,3,1) == "r") $checked[gr] = "checked";
	if (substr($mode,4,1) == "w") $checked[gw] = "checked";
	if (substr($mode,6,1) == "r") $checked[pr] = "checked";
	if (substr($mode,7,1) == "w") $checked[pw] = "checked";
	
	return $checked;
}

// Generate select form
function form_select_workgroup($email, $selected)
{
	global $l,$HTTP_SESSION_VARS;
	
	if (user_is_cko()){
		$strsql = "SELECT WGID,NAME 
					FROM workgroup
					ORDER BY NAME ";
	} else {
		$strsql = "SELECT rel_workgroup_user.WGID, workgroup.NAME 
					FROM workgroup, rel_workgroup_user
					WHERE rel_workgroup_user.EMAIL = '$email' AND
							rel_workgroup_user.WGID = workgroup.WGID
					ORDER BY workgroup.NAME ";
	}
	
	$dbres = mysql_query($strsql);
	if ($dbres){
		while ($row = mysql_fetch_array($dbres)){
			$wgid = $row[WGID];
			$html .= "
				<option value=$wgid $selected[$wgid]>".string_substr($row[NAME],15)."</option>";
		}
		if (!empty($html)){
			return "
				<select name=wgid style=\"font-family: Arial; font-size: 8pt\">
					<option value=0 $selected[0]>$l[private]</option>
					$html
				</select>";
		} else {
			return $l[no_wg_assigned];
		}
	} else {
		stdout_error(mysql_error());
	}
	return;
}

// Create organization selection form
function form_select_orgname($frmorg)
{

	$orginfo = explorer_pname_to_node("/Organization");
	if (empty($orginfo[NODE])) $orginfo = explorer_pname_to_node("/Organisasi");
	if (empty($orginfo[NODE])) $orginfo = explorer_pname_to_node("/Direktori_Keahlian");
	
	$orgnode = $orginfo[NODE];
	$orgpath = "$orginfo[PATH]$orginfo[NODE]";
	
	$sel[$frmorg] = "selected";	
	
	// show selected orgname
	if (!empty($frmorg)){
		$html = "
			<option value=\"$frmorg\" ".$sel[$frmorg].">$frmorg</option>
			<option value=\"\">----------------------------------</option>
			";
	}
				
	$strsql = "SELECT folder.NAME 
					FROM folder, folder_tree
					WHERE
						folder.NODE = folder_tree.NODE AND
						folder_tree.PATH LIKE '$orgpath/%' AND
						folder.TYPE = 'organization'
					ORDER BY folder.NAME ";
	
	$dbres = mysql_query($strsql);
	if ($dbres){
		while ($row = mysql_fetch_array($dbres)){
			$orgname = $row[NAME];
			$html .= "
				<option value=\"$orgname\" ".$sel[$orgname].">".str_replace("_"," ",$orgname)."</option>";
		}
		return $html;
	} else {
		stdout_error(mysql_error());
		return 0;
	}
	
}

%>