<%
/***************************************************************************
                  import.php  -  function related to importing metadata
                             -------------------
    begin                : Sept, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 

if (defined ('import_php')) { 
	return; 
} else { 
	define ('import_php', true); 
}

require_once "functions/xmlparser.php";
require_once "functions/stdout.php";
require_once "functions/hub.php";

// import metadata xml
function import_metadata($xmldata,$status,$box)
{
	global $HTTP_SESSION_VARS;
	
	$xml = readXML($xmldata);
	
	switch($status){
		case "new":
			$strsql_metadata = "INSERT INTO metadata
						(
							SCHEMA,
							IDENTIFIER,
							DATEMODIFIED,
							DATE,
							PUBLISHER,
							OWNER,
							TYPE,
							RELATION_COUNT

						)
					VALUES
						(
							'".$xml["TYPE.SCHEMA"][0]."',
							'".$xml[IDENTIFIER][0]."',
							'".$xml["DATE.MODIFIED"][0]."',
							'".$xml[DATE][0]."',
							'".$xml[PUBLISHER][0]."',
							'".$xml["CONTRIBUTOR.MODIFIEDBY"][0]."',
							'".$xml[TYPE][0]."',
							'".$xml["RELATION.COUNT"][0]."'
						) ";
			
			$strsql_xmldata = "INSERT INTO metadata_xml
					VALUES
						(
							'".$xml[IDENTIFIER][0]."',
							'".addslashes($xmldata)."'
						) ";
						
			$strsql_inbox = "INSERT INTO $box
						(
							TYPE,
							IDENTIFIER,
							STATUS,
							FOLDER,
							DATEMODIFIED
						)
					VALUES
						(
							'metadata',
							'".$xml[IDENTIFIER][0]."',
							'success',
							'received',
							'".$xml["DATE.MODIFIED"][0]."'
						)
						";
						
			break;
		case "update":
			$strsql_metadata = "UPDATE metadata
						SET
							SCHEMA 		= '".$xml["TYPE.SCHEMA"][0]."',
							DATEMODIFIED 	= '".$xml["DATE.MODIFIED"][0]."',
							DATE 			= '".$xml[DATE][0]."',
							PUBLISHER 		= '".$xml[PUBLISHER][0]."',
							OWNER 			= '".$xml["CONTRIBUTOR.MODIFIEDBY"][0]."',
							TYPE 			= '".$xml[TYPE][0]."',
							RELATION_COUNT = '".$xml["RELATION.COUNT"][0]."'

						WHERE IDENTIFIER = '".$xml[IDENTIFIER][0]."'";
			
			$strsql_xmldata = "UPDATE metadata_xml
						SET
							XMLDATA = '".addslashes($xmldata)."'
						WHERE 
							IDENTIFIER = '".$xml[IDENTIFIER][0]."'";
			
			$strsql_inbox = "UPDATE $box
						SET DATEMODIFIED = '".$xml["DATE.MODIFIED"][0]."'
						WHERE IDENTIFIER = '".$xml[IDENTIFIER][0]."'";
						
			break;
		case "deleted":
			$strsql_metadata = "DELETE FROM metadata WHERE
							IDENTIFIER = '".$xml[IDENTIFIER][0]."'";
			$strsql_xmldata = "DELETE FROM metadata_xml WHERE
							IDENTIFIER = '".$xml[IDENTIFIER][0]."'";
			$strsql_inbox = "DELETE FROM $box WHERE IDENTIFIER = '".$xml[IDENTIFIER][0]."'";
			
			break;
		default:
			
	}

	// execute
	$dbres1 = mysql_query($strsql_metadata);
	if ($dbres1){
		// xmldata
		$dbres2 = mysql_query($strsql_xmldata);
		$dbres3 = mysql_query($strsql_inbox);
		
		$insid = mysql_insert_id();
		if (ereg("INSERT",$strsql_metadata)) {
			$mystatus = "new";
		} else if (ereg("DELETE",$strsql_metadata)){
			$mystatus = "deleted";
		} else {
			$mystatus = "update";
		}
	} else {
		if (ereg("Duplicate",mysql_error())) {
			$dbres3 = mysql_query($strsql_inbox);
			$mystatus = "updated";
			import_metadata($xmldata,"update",$box);
		}
	}
	
	if ($status == "new"){
		// update folder
		$folder_info = import_check_create_folder($xml[PUBLISHER][0],$xml["IDENTIFIER.HIERARCHY"][0]);
		
		// put metadata in a folder
		import_metadata_folder($xml[IDENTIFIER][0],$folder_info[parent],$folder_info[tree]);
	}
	
	$result[status] = $mystatus;

	return $result;
}

// check and create folder
function import_check_create_folder($providerId,$path)
{
	global $conf,$tmp_providerNetwork;
	
	// get providerNetwork
	if (!is_array($tmp_providerNetwork)) {
		$tmp_providerNetwork = import_get_providerNetwork();
		$providerNetwork = $tmp_providerNetwork[$providerId];
	} else {
		$providerNetwork = $tmp_providerNetwork[$providerId];
	}
	
	if (empty($providerNetwork)) $providerNetwork = "General";
	
	// strip previous IndonesiaDLN/*String path
	$path = str_replace("/IndonesiaDLN/*Institution/$providerId","",$path);
	$path = str_replace("/*Institution/$providerId","",$path);
	
	// collection path
	if ($path == "/Discussion/"){
		$collection_path = $path;
	} else {
		$collection_path = "/$conf[collection_folder]/$providerNetwork/$providerId".$path;
	}
	
	$folders = explode("/",$collection_path);
	$parent_id = 0;
	$folder_tree = "0/";
	
	while (list($key,$val) = each($folders)){
		if (empty($val)) continue;
		
		$folder_node = import_check_folder($val,$parent_id);
		if ($folder_node == "err") {
			$folder_node = import_create_folder($val,$parent_id,$folder_tree,$providerId);
			$folder_tree .= "$folder_node/";
		} else {
			$folder_tree .= "$folder_node/";
		}
		$parent_id = $folder_node;
	}
	
	$folder_info[tree] = $folder_tree;
	$folder_info[parent] = $parent_id;
	$folder_info[path] = $collection_path;
	
	return $folder_info;
	
}

// get providerNetwork
function import_get_providerNetwork()
{
	$strsql = "SELECT DC_PUBLISHER_ID,DC_PUBLISHER_NETWORK FROM publisher";
	$dbres = mysql_query($strsql);
	if ($dbres){
		while ($row = mysql_fetch_array($dbres)){
			$id = $row[DC_PUBLISHER_ID];
			$tmp_providerNetwork[$id] = $row[DC_PUBLISHER_NETWORK];
		}
		return $tmp_providerNetwork;
	} else {
		echo "import_get_providerNetwork(): ".mysql_error();
		return;
	}
}

// check and get id of a folder
function import_check_folder($folder_name,$parent_id)
{
	$strsql = "SELECT folder.NODE FROM folder,folder_tree
					WHERE 
						folder.TYPE = 'folder' AND 
						folder.NAME = '$folder_name' AND
						folder_tree.PARENT = '$parent_id' AND
						folder.NODE = folder_tree.NODE
						";
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0) {
			$folder_node = mysql_result($dbres,0,"NODE");
			return $folder_node;
		} else {
			return "err";
		}
	} else {
		stdout_error("import_check_folder(): ".mysql_error());
		return "err";
	}
}

// create folder
function import_create_folder($folder_name,$parent_id,$folder_tree,$providerId)
{
	global $HTTP_SESSION_VARS;

	// table folder
	$strsql = "INSERT INTO folder
					(
						TYPE,
						NAME,
						OWNER,
						WGID,
						MODE,
						DATEMODIFIED,
						PUBLISHER
					)
				VALUES
					(
						'folder',
						'$folder_name',
						'superuser@localhost',
						'0',
						'rw-r--r-',
						'".date("Y-m-d H:i:s")."',
						'$providerId'
					)";
	
	$dbfolder = mysql_query($strsql);
	if ($dbfolder){
		$folder_node = mysql_insert_id();
	} else {
		stdout_error("import_create_folder(): ".mysql_error());
	}
	
	// table folder_tree
	
	$strsql = "INSERT INTO folder_tree
					(
						PARENT,
						NODE,
						PATH
					)
				VALUES 
					(
						'$parent_id',
						'$folder_node',
						'$folder_tree'
					)";
	$dbtree = mysql_query($strsql);
	if ($dbtree){
		return $folder_node;
	} else {
		stdout_error("import_create_folder(): ".mysql_error());
		return;
	}
	
}

// put metadata in a folder
function import_metadata_folder($identifier,$parent_id,$folder_tree)
{

	if (empty($identifier)) return;
	
	// check if exists
	$strchk = "SELECT PARENT FROM folder_tree WHERE IDENTIFIER = '$identifier'";
	$dbchk = mysql_query($strchk);
	if ($dbchk){
		if (mysql_num_rows($dbchk)>0){
			$myparent = mysql_result($dbchk,0,"PARENT");
			if ($myparent == $parent_id) return;
		}
	} else {
		echo "import_metadata_folder(): ".mysql_error();
		return;
	}

	$strsql = "INSERT INTO folder_tree (IDENTIFIER, PARENT, PATH)
						VALUES ('$identifier','$parent_id','$folder_tree')";
	
	$dbres = mysql_query($strsql);
	if (!$dbres){
		echo "Server error: import_metadata_folder(). ".mysql_error();
	}
	return;
}

// Import providers
function import_providers($data)
{
	global $frm;
	
	$xml = readXML($data);
	
	$frm = import_providers_xml_to_frm($xml);
	
	$id = $xml[DC_PUBLISHER_ID][0];
	$datemod = $xml[DC_PUBLISHER_DATEMODIFIED][0];
	
	// check
	$strsql = "SELECT DC_PUBLISHER_DATEMODIFIED FROM publisher 
					WHERE DC_PUBLISHER_ID = '$id'";
					
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$mydatemod = mysql_result($dbres,0,"DC_PUBLISHER_DATEMODIFIED");
			if ($datemod > $mydatemod){
				// update
				hub_publisher_edit($id,"from_sync");
				$status = "updated";
			} else {
				// uptodate
				$status = "*";
			}
		} else {
			// add
			hub_publisher_add($id);
			$status = "new";
		}
	} else {
		echo "import_providers(): ".mysql_error();
	}
	
	$result[id] = $id;
	$result[status] = $status;
	
	return $result;
}

// xml to frm
function import_providers_xml_to_frm($xml)
{
	while (list($key,$val) = each($xml)){
		$frm_key = str_replace("DC_","",strtoupper($key)); 
		$frm[$frm_key] = $xml[$key][0];
	}
	return $frm;
}

%>