<%
/***************************************************************************
                          metadata.php  -  function related to metadata processing
                             -------------------
    begin                : June 14, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 

if (defined ('metadata_php')) { 
	return; 
} else { 
	define ('metadata_php', true); 
}

require_once "functions/db.php";
require_once "functions/stdout.php";
require_once "functions/explorer.php";
require_once "functions/xmlparser.php";
require_once "functions/user.php";


// Generate metadata identifier
function metadata_generate_identifier()
{
	global $DC_PUBLISHER_ID, $DC_PUBLISHER_APPS, $frm;
	
	// format
	// publisherid-gdl-type-year-author-num
		
	// count total metadata
	$strsql = "SELECT count(*) as TOTAL FROM metadata
				WHERE PUBLISHER = '$DC_PUBLISHER_ID'";
	
	$publisherid = $DC_PUBLISHER_ID;
	$apps = $DC_PUBLISHER_APPS;
	$type = $frm[TYPE];
	$year = substr($frm[DATE],0,4);
	
	// author
	if ($frm[TYPE_SCHEMA] == "dc_person") $frm[CREATOR] = $frm[PERSON_FULLNAME];
	if ($frm[TYPE_SCHEMA] == "dc_organization") $frm[CREATOR] = $frm[ORGANIZATION_NAME];
	
	$author = str_replace(" ","",trim($frm[CREATOR]));
	$author = ereg_replace("[^<>[:alnum:]]","", $author);
	$author = substr($author,0,10);
	
	$num = db_total_records($strsql) + 1;
	
	// default
	if (empty($type)) $type = "ttt";
	if (empty($author)) $author= "aaa";
	
	
	$identifier = strtolower("$publisherid-$apps-$type-$year-$author-$num");
	
	return $identifier;
	
}
	
// Generate metadata xml
function metadata_generate_xml($form_action)
{
	global $frm, $e;
	
	// get schema
	$schema = "schemas/$frm[TYPE_SCHEMA].xml";
	if (file_exists($schema)){
	
		// get element values
		$schema_values = $schema."-values.inc";
		if (file_exists($schema_values)){
			include $schema_values;
			get_element_special_values();
		} 
		
		metadata_generate_properties($form_action);
	
		$str_meta = join('',file($schema));
		while(list($key,$val) = each($frm)){
			$value = htmlspecialchars(nl2br($val),ENT_QUOTES);
			$str_meta = str_replace("#$key#",$value,$str_meta);
		}
		
		return $str_meta;
	} else {
		$errmsg = "metadata_generate_xml(): Error file schema <b>$schema</b> $e[notfound]";
		stdout_error($errmsg);
		return 0;
	}
	
}
	
// Generate metadata properties
function metadata_generate_properties($form_action)
{
	global $frm, $DC_PUBLISHER_ID, $HTTP_SESSION_VARS;
	
	if ($form_action == "NOPROP") return;
	
	if ($form_action == "ADD")	$frm[IDENTIFIER] 	= metadata_generate_identifier();
	
	$path = explorer_path($HTTP_SESSION_VARS[sess_upload_address],0);
	$frm[IDENTIFIER_HIERARCHY] = $path[HIERARCHY];
	
	$frm[PUBLISHER]	= $DC_PUBLISHER_ID;
	$frm[DATE_MODIFIED]	= date("Y-m-d H:i:s");
	
	return;
	
}

// Read metadata from db
function metadata_read_db($id)
{
	global $e;
	
	$strsql = "SELECT XMLDATA FROM metadata_xml 
					WHERE IDENTIFIER = '$id' AND
					XMLDATA <> 'deleted'
					";
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres) > 0){
		
			// htmlspecialchars table
			$trans = get_html_translation_table(HTML_SPECIALCHARS);
			$trans = array_flip($trans);
			
			$xmldata = mysql_result($dbres,0,"XMLDATA");
			
			if (!empty($xmldata)){
				$xml = readXML($xmldata);
				//echo "<pre>";
				while (list($key,$val) = each($xml)){
					//echo "$key - ".$xml[$key][0]."\n";
					$elem = str_replace(".","_",$key);
					
					$xdata = $xml[$key][0];
					$xdata = strtr($xdata,$trans);
					$xdata = str_replace("<br />","\n",$xdata);
					$frm[$elem] = $xdata;

				}
				
				// relation count
				$minfo = metadata_info($id);
				$frm[RELATION_COUNT] = $minfo[RELATION_COUNT];
				
				return $frm;
			} else {
				//stdout_error("Warning: Metadata id =<b> $id</b> $e[isempty]");
				return 0;
			}
			
		} else {
			//stdout_error("Error: Metadata id = <b>$id</b> $e[notfound]");
			return 0;
		}
	} else {
		stdout_error(mysql_error());
		return 0;
	}
}

// Read metadata from db
function metadata_read_xml($id)
{
	global $e;
	
	$strsql = "SELECT XMLDATA FROM metadata_xml WHERE IDENTIFIER = '$id' AND XMLDATA <> 'deleted'";
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres) > 0){
		
			// htmlspecialchars table
			$trans = get_html_translation_table(HTML_SPECIALCHARS);
			$trans = array_flip($trans);
			
			$xmldata = mysql_result($dbres,0,"XMLDATA");
			
			if (!empty($xmldata)){
				$xml = readXML($xmldata);
				//echo "<pre>";
				while (list($key,$val) = each($xml)){
					//echo "$key - ".$xml[$key][0]."\n";
					$elem = str_replace(".","_",$key);
					
					for ($i=0;$i<sizeof($xml[$key]);$i++){
						$xdata = $xml[$key][$i];
						$xdata = strtr($xdata,$trans);
						$frm[$elem][] = $xdata;
					}
				}
							
				return $frm;
			} else {
				//stdout_error("Warning: Metadata id =<b> $id</b> $e[isempty]");
				return 0;
			}
			
		} else {
			//stdout_error("Error: Metadata id = <b>$id</b> $e[notfound]");
			return 0;
		}
	} else {
		stdout_error(mysql_error());
		return 0;
	}
}

// get metadata
function metadata_info($id)
{
	global $e;
	
	$strsql = "SELECT *
					FROM metadata 
					WHERE IDENTIFIER = '$id'
					";
					
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$row = mysql_fetch_array($dbres);
			return $row;
		} else {
			//stdout_error("Error: Metadata id = <b>$id</b> $e[notfound]");
			return 0;
		}
	} else {
		stdout_error(mysql_error());
		return 0;
	}
}

// count comments number
function metadata_num_comments($id)
{
	$strsql = "SELECT count(*) AS TOTAL FROM folder_tree
				WHERE IDENTIFIER LIKE '$id\@%'";
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$num = mysql_result($dbres,0,"TOTAL");
			return $num;
		} else {
			return 0;
		}
	} else {
		stdout_error("metadata_num_comment(): ".mysql_error());
		return 0;
	}
}

// get metadata path
function metadata_path($id)
{
	$strsql = "SELECT PATH FROM folder_tree WHERE IDENTIFIER = '$id'";

	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$path = mysql_result($dbres,0,"PATH");
			return $path;
		}
	} else {
		stdout_error(mysql_error());
		return 0;
	}
}

// get metadata path
function metadata_parent($id)
{
	$strsql = "SELECT PARENT FROM folder_tree WHERE IDENTIFIER = '$id'";

	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$parent = mysql_result($dbres,0,"PARENT");
			return $parent;
		}
	} else {
		stdout_error(mysql_error());
		return 0;
	}
}

// show the metadata link
function  metadata_link($row,$side)
{
	global $HTTP_SESSION_VARS;
	
	if ($HTTP_SESSION_VARS[sess_explorer_pane] == 2)
		$shlen = 20;
	else
		$shlen = 30;
	
	$shid = $HTTP_SESSION_VARS[sess_explorer_shid];
	
	if ($shid == "identifier"){
		$strtitle = string_substr_front($row[IDENTIFIER],$shlen);
	} else {
		$xml = metadata_read_xml($row[IDENTIFIER]);
		$strtitle = substr($xml[TITLE][0],0,$shlen)."..";
	}
	
	if (explorer_folder_iswrite("metadata",$row[IDENTIFIER])) {
  		$html = "
  			<a href=/office.php?m=explorer&type=metadata&id=$row[IDENTIFIER]&b=edit&w=$side><img border=0 src=/images/editsml.gif alt=$l[edit]></a>";
  		if ($HTTP_SESSION_VARS[sess_explorer_pane] == 2)
  			$html .= "<input type=checkbox name=cboxid[$side][] value=$row[IDENTIFIER]>";
   	} 
   	
   	$html .= "<a href=/go.php?id=$row[IDENTIFIER]>$strtitle</a>";
   
   
	return $html;     	
}

// change relation count
function metadata_change_relation_count($id,$newcount){
	$strsql = "UPDATE metadata SET RELATION_COUNT = '$newcount'
					WHERE IDENTIFIER = '$id'";
	$dbres = mysql_query($strsql);
	if ($dbres){
		return TRUE;
	} else {
		stdout_error(mysql_error());
		return FALSE;
	}
}

// define file directory and name
function metadata_relation_info($id,$no)
{
	global $conf,$frm,$HTTP_POST_FILES;
	
	// directory
	$arid = explode("-",$id);
	$meta_no = $arid[sizeof($arid)-1];
	$groupdir = ceil($meta_no/$conf[metadata_per_dir]);
	$homedir  = "$conf[repository_dir]/$groupdir";
	
	// filename
	$fname = $HTTP_POST_FILES[filerelation][name][$no];
	if (strlen($fname)>13){
		$fext = substr($fname,-5);
		$fpart = substr($fname,0,8);
		$fname2 = "$fpart-$fext";
	} else {
		$fname2 = $fname;
	}
	// substr
	$fpart = str_replace("%","",urlencode($fname2));
	
	
	if (!file_exists($homedir)){
		mkdir ($homedir,0755);
	}
	
	// file info
	$rel[no]			= $no;
	$rel[hasfilename]	= $fname;
	$rel[haspart]		= "$id-$fpart";
	$rel[haspath]		= "$homedir/$rel[haspart]";
	$rel[hasuri]	 	= htmlspecialchars("/download.php?id=$id&no=$no");
	$rel[hasformat]	= $HTTP_POST_FILES[filerelation][type][$no];
	$rel[hassize]		= $HTTP_POST_FILES[filerelation][size][$no];
	$rel[hasnote]		= htmlspecialchars($frm[RELATION_HASNOTE][$no]);
	
	$rel[source] 		= $HTTP_POST_FILES[filerelation][tmp_name][$no];

	//print_r($rel);
	
	return $rel;
	
}

// read info from database
function  metadata_relation_dbinfo($id)
{
	$strsql = "SELECT * FROM relation WHERE IDENTIFIER  = '$id' ORDER BY NO";
	

	$dbres = mysql_query($strsql);
	if ($dbres){
		while ($row = mysql_fetch_array($dbres)){
			$no = $row[NO];
			$rel[RELATION_DATEMODIFIED][$no]	= $row[DATEMODIFIED];
			$rel[RELATION_HASFILENAME][$no]	= $row[HASFILENAME];
			$rel[RELATION_HASPART][$no] 		= $row[HASPART];
			$rel[RELATION_HASPATH][$no] 		= $row[HASPATH];
			$rel[RELATION_HASFORMAT][$no] 		= $row[HASFORMAT];
			$rel[RELATION_HASSIZE][$no] 		= $row[HASSIZE];
			$rel[RELATION_HASURI][$no] 			= $row[HASURI];
			$rel[RELATION_HASNOTE][$no] 		= $row[HASNOTE];
		}
		if (isset($rel)) {
			return $rel;
		} else {
			return 0;
		}
	} else {
		stdout_error(mysql_error());
		return 0;
	}
}

// generate relations xml
function metadata_generate_relation($id,$num)
{

	$rinfo = metadata_relation_dbinfo($id);
	
	if (!is_array($rinfo)) return;
	
	$relation_schema = "schemas/relation.xml";
	if (file_exists($relation_schema)){
		$xml = join('',file($relation_schema));
		$no = array_keys($rinfo[RELATION_HASPART]);
		for ($i=1;$i<=sizeof($rinfo[RELATION_HASPART]);$i++){
			$xmltmp = $xml;
			
			$nomor = $no[$i-1];
			
			//if ($num < $nomor) break;
			
			$xmltmp = str_replace("#RELATION_NO#",$nomor,$xmltmp);
			reset($rinfo);
			while (list($key,$val) = each($rinfo)){
				$xmltmp = str_replace("#$key#",$rinfo[$key][$nomor],$xmltmp);
			}
			$xml_res .= $xmltmp;
			if ($num == $i) break;
		}
		return $xml_res;
	} else {
		stdout_error("metadata_generate_relation(): $relation_schema is not found");
		return 0;
	}

}

// add relation to metadata
function metadata_relation_append($id)
{
	global $frm;
	
	// read metadata
	$frm = metadata_read_db($id);

	// generate metadata
	$xml = metadata_generate_xml("UPDATE");
	
	// append relation
	$xml_rel = metadata_generate_relation($id,$frm[RELATION_COUNT]);
	
	$xml = str_replace("<relation>#RELATION_EXTERNAL_ENTITIES#</relation>",$xml_rel,$xml);
	$xml = metadata_cleaning_xml($xml);
	
	db_metadata_update($id,$xml);
	
	return;
	
}

// clean up empty element
function metadata_cleaning_xml($xml)
{
	$xml = ereg_replace("#[[:alpha:]]+#","",$xml);
	$xml = ereg_replace("#[[:alpha:]]+_[[:alpha:]]+#","",$xml);
	$xml = ereg_replace("#[[:alpha:]]+_[[:alpha:]]+_[[:alpha:]]+#","",$xml);
	
	return $xml;
	
}

// read publisher info
function metadata_publisher_info($publisherid)
{
	$strsql = "SELECT * FROM publisher WHERE DC_PUBLISHER_ID = '$publisherid'";
	$dbres = mysql_query($strsql);
	if ($dbres){
		$row = mysql_fetch_array($dbres);
		return $row;
	} else {
		stdout_error(mysql_error());
		return;
	}
}

%>