<%
/***************************************************************************
                  oaipmh.php  -  function related to OAI PMH
                             -------------------
    begin                : Jan 2003
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 

if (defined ('oaipmh_php')) { 
	return; 
} else { 
	define ('oaipmh_php', true); 
}

require_once "functions/xmlparser.php";
require_once "functions/import.php";
require_once "functions/oaipmp.php";


// ************************* ListIdentifiers **********************
function oaipmh_request_ListIdentifiers($token)
{
	global $conf, $HTTP_SESSION_VARS;
	
	// start request
	$REQUEST = "verb=ListIdentifiers".
				 "&PHPSESSID=".$HTTP_SESSION_VARS[sess_connect_sessionid].
				 "&set=under:node:$conf[sync_harvest_node]";
	
	if ($token > 0) $REQUEST .= "&resumptionToken=$token";
	
	$URI = "http://$conf[sync_hub_server_name]/$conf[sync_oai_script]?$REQUEST";
	
	$HEADER = "GET $URI HTTP/1.0\r\n\r\n";
	
	return $HEADER;
}

// Response
function oaipmh_response_ListIdentifiers()
{
	global $set,$resumptionToken;
	
	// get requests
	$verb = "ListIdentifiers";
	$args = oaipmp_get_request();
	
	// check argument
	if (!oaipmp_check_session($verb)){
		return 0;
	}  else {
	
		// get elements
		$identifiers = oaipmh_element_ListIdentifiers($set,$resumptionToken);
		$elements = array("ListIdentifiers",$identifiers);
		$response = oaipmh_generate_response($verb,$args,$elements);
	}
	
	echo $response;
}

// Get elements
function oaipmh_element_ListIdentifiers($set,$token)
{
	if (ereg("under:node:",$set)){
		$node = substr($set,11);
		$path = oaipmh_node_path($node);
		$element = oaipmh_get_identifiers($path,$token);

	} else {
		$element = oaipmp_element_error("badArgument","Sorry, currently we only receive argument 'set' which is 
    		prefixed by 'under:node:' string.");
	}
	
	return $element;
}

// Get node info
function oaipmh_node_path($node)
{
	$strsql = "SELECT PATH FROM folder_tree WHERE NODE = '$node'";
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0) {
			$path = mysql_result($dbres,0,"PATH")."$node/";
			return $path;
		} else {
			return 0;
		}
	} else {
		return 0;
	}
}

// get total
function oaipmh_get_total_identifiers($path,$from,$requesterId)
{
	
	$strsql = "SELECT count(distinct metadata.IDENTIFIER) as TOTAL 
					FROM 
						folder_tree,metadata
					WHERE 
						folder_tree.IDENTIFIER IS NOT NULL AND
						folder_tree.IDENTIFIER = metadata.IDENTIFIER AND
						metadata.DATEMODIFIED >= '$from' AND
						metadata.PUBLISHER <> '$requesterId' AND
						folder_tree.PATH LIKE '$path%'";
	
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0) $total = mysql_result($dbres,0,"TOTAL");
		return $total;
	} else {
		echo mysql_error();
		return 0;
	}
}

// get identifiers from database
function oaipmh_get_identifiers($path, $token)
{
	global $conf, $HTTP_SESSION_VARS;
	
	if (empty($token)) $token = 0;
	$cursor = $token * $conf[perpage_ListIdentifiers];
	
	$strsql = "SELECT distinct metadata.IDENTIFIER,metadata.DATEMODIFIED,metadata.TYPE,metadata.STATUS
					FROM 
						folder_tree,metadata
					WHERE 
						folder_tree.IDENTIFIER = metadata.IDENTIFIER AND
						folder_tree.PATH LIKE '$path%'
					LIMIT $cursor,$conf[perpage_ListIdentifiers] ";
	
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			while($row = mysql_fetch_array($dbres)){
				$header .= oaipmh_element_header($row[STATUS],$row[IDENTIFIER],$row[DATEMODIFIED],$row[TYPE]);
			}
			
			// get resumption token
			$total = oaipmh_get_total_identifiers($path,$from,$requesterId);
			$resumption_token = oaipmh_element_resumptiontoken($token, $conf[perpage_ListIdentifiers],$total);
			
			$element = "
  <ListIdentifiers>$header $resumption_token
  </ListIdentifiers>";
  
		} else {
			$element = oaipmp_element_error("noRecordsMatch","Record not found");
		}
	} else {
		$element = oaipmp_element_error("dbError",mysql_error());
	}
	
	return $element;
}

// ********** ResumptionToken ************

// get resumption token
function oaipmh_element_resumptiontoken($token,$limit,$total)
{
	global $conf;
	
	
	$cursor = $token * $limit;
	$cursor2 = $cursor + $limit;
	if ($cursor2 > $total) $cursor2 = $total;
	$token2 = $token + 1;
	
	if ($cursor2 <= $total){
		$resumption = "
    <resumptionToken 
       completeListSize=\"$total\"
       cursor=\"$cursor\">$token2</resumptionToken>";
	}
	return $resumption;
}


// ************************* ListRecords ***************************

// request
function oaipmh_request_ListRecords($from,$token)
{
	global $conf, $HTTP_SESSION_VARS;
	

	// start request
	$REQUEST = "verb=ListRecords".
				 "&PHPSESSID=".$HTTP_SESSION_VARS[sess_connect_sessionid].
				 "&set=under:node:$conf[sync_harvest_node]".
				 "&from=$from".
				 "&limit=$conf[sync_count_records]".
				 "&resumptionToken=$token";
	
	$URI = "http://$conf[sync_hub_server_name]/$conf[sync_oai_script]?$REQUEST";
	
	$HEADER = "GET $URI HTTP/1.0\r\n\r\n";
	
	return $HEADER;

}

// response
function oaipmh_response_ListRecords()
{
	global $set,$from,$resumptionToken,$limit;
	
	// get requests
	$verb = "ListRecords";
	$args = oaipmp_get_request();
	
	// check argument
	if (!oaipmp_check_session($verb)){
		return 0;
	}  else {
	
		// get elements
		$list_records = oaipmh_element_ListRecords($set,$from,$resumptionToken,$limit);
		$elements = array("ListRecords",$list_records);
		$response = oaipmh_generate_response($verb,$args,$elements);
	}
	
	echo $response;
}

// elements
function oaipmh_element_ListRecords($set,$from,$token,$limit)
{
	
	if (ereg("under:node:",$set)){
		$node = substr($set,11);
		$path = oaipmh_node_path($node);
		$element = oaipmh_get_records($path,$from,$token,$limit);

	} else {
		$element = oaipmp_element_error("badArgument","Sorry, currently we only receive argument 'set' which is 
    		prefixed by 'under:node:' string.");
	}
	
	return $element;

}

// get records
function oaipmh_get_records($path,$from,$token,$limit)
{
	global $conf, $HTTP_SESSION_VARS;
	
	$requesterId = $HTTP_SESSION_VARS[sess_providerId];
	
	if (strlen($from) == 20){
		$from = str_replace("T"," ",$from);
		$from = str_replace("Z","",$from);
	} 
	
	if (empty($token)) $token = 0;
	$cursor = $token * $limit;
	
	$strsql = "SELECT distinct metadata.IDENTIFIER,metadata.DATEMODIFIED,
						metadata.TYPE,metadata.STATUS,metadata_xml.XMLDATA
					FROM 
						folder_tree,metadata,metadata_xml
					WHERE 
						metadata.DATEMODIFIED >= '$from' AND
						folder_tree.IDENTIFIER = metadata.IDENTIFIER AND
						folder_tree.IDENTIFIER = metadata_xml.IDENTIFIER AND
						metadata.PUBLISHER <> '$requesterId' AND
						folder_tree.PATH LIKE '$path%'
					ORDER BY metadata.DATEMODIFIED ASC
					LIMIT $cursor,$limit";
	
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			while($row = mysql_fetch_array($dbres)){
				$header   = oaipmh_element_header($row[STATUS],$row[IDENTIFIER],$row[DATEMODIFIED],$row[TYPE]);
				
				if ($row[STATUS] != "deleted"){
					$metadata = oaipmp_element_metadata($row[XMLDATA]);
				}
							
				$record = "
   <record>$header $metadata
   </record>";
    			
    			$records .= $record;
			}
			
			// get resumption token
			$total = oaipmh_get_total_identifiers($path,$from,$requesterId);
			$resumption_token = oaipmh_element_resumptiontoken($token, $limit,$total);
			
			$element = "
  <ListRecords>$records $resumption_token
  </ListRecords>";
  
		} else {
			$element = oaipmp_element_error("noRecordsMatch","Record not found");
		}
	} else {
		$element = oaipmp_element_error("dbError",mysql_error());
	}
	
	return $element;
}

// last date modified
function oaipmh_last_datemodified($box)
{
	$strsql = "SELECT DATEMODIFIED FROM $box ORDER BY DATEMODIFIED DESC LIMIT 0,1";
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$datemodified = mysql_result($dbres,0,"DATEMODIFIED");
		} else {
			$datemodified = 0;
		}
	} else {
		$datemodified = 0;
		echo mysql_error();
	}
	return $datemodified;
}

// ******************* ListProviders *******************
// request
function oaipmh_request_ListProviders($token)
{
	global $conf, $HTTP_SESSION_VARS;
	

	// start request
	$REQUEST = "verb=ListProviders".
				 "&PHPSESSID=".$HTTP_SESSION_VARS[sess_connect_sessionid].
				 "&limit=$conf[sync_count_records]".
				 "&resumptionToken=$token";
	
	$URI = "http://$conf[sync_hub_server_name]/$conf[sync_oai_script]?$REQUEST";
	
	$HEADER = "GET $URI HTTP/1.0\r\n\r\n";
	
	return $HEADER;
		
}

// response
function oaipmh_response_ListProviders()
{
	global $resumptionToken,$limit;
	
	// get requests
	$verb = "ListProviders";
	$args = oaipmp_get_request();
	
	// check argument
	if (!oaipmp_check_session($verb)){
		return 0;
	}  else {
	
		// get elements
		$list_records = oaipmh_element_ListProviders($limit,$resumptionToken);
		$elements = array("ListProviders",$list_records);
		$response = oaipmh_generate_response($verb,$args,$elements);
	}
	
	echo $response;	
	
}

// elements ListProviders
function oaipmh_element_ListProviders($limit,$resumptionToken)
{
	global $HTTP_SESSION_VARS,$DC_PUBLISHER_ID;
	
	$cursor = $limit * $resumptionToken;
	
	$strsql = "SELECT * FROM publisher
				WHERE DC_PUBLISHER_HUBSERVER <> '$HTTP_SESSION_VARS[sess_providerId]' 
				LIMIT $cursor,$limit";
	
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			while ($row = mysql_fetch_array($dbres)){
				$pubid = $row[DC_PUBLISHER_ID];
				// generate element
				while (list($key,$val) = each($row)){
					if (!is_numeric($key)){
						$elm = strtolower($key);
						// hide serial number
						if (($key == "DC_PUBLISHER_SERIALNO") && ($pubid != $DC_PUBLISHER_ID))
							$value = "-- not disseminated --";
						else 
							$value = $val;
						
						// generate element
						$record .= "
      <$elm>$value</$elm>";
					}			
				}
				
				$list .= "
    <record>$record
    </record>";
  				
  				// reset record
  				$record = "";
  			}
  			
  			// resumption token
  			$total = oaipmh_total_providers();
  			$resumption_token = oaipmh_element_resumptiontoken($resumptionToken, $limit,$total);
  			
  			// generate element ListProviders
  			
  			$element = "
  <ListProviders>$list $resumption_token
  </ListProviders>";
	
		} else {
			$element = oaipmp_element_error("noRecordsMatch","Record not found");
		}		
	} else {
		$element = oaipmp_element_error("dbError",mysql_error());
	}
	
	return $element;
}

// Total providers
function oaipmh_total_providers()
{
	global $HTTP_SESSION_VARS;
	
	$strsql = "SELECT COUNT(*) as TOTAL FROM publisher 
		WHERE DC_PUBLISHER_HUBSERVER <> '$HTTP_SESSION_VARS[sess_providerId]' ";
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$total = mysql_result($dbres,0,"TOTAL");
		} else {
			$total = 0;
		}
	} else {
		$total = 0;
	}

	return $total;
}

// Extract providers xml
function oaipmh_extract_providers($data)
{
	$arr_data = explode("\n",$data);
	
 	$results[size] = strlen($data);
	
	$no = 0;
	
	while(list($key,$val) = each($arr_data)){
		
		// check start boundaries
		if (ereg("<record>",$val)) {
			$metadata_start = 1;
			continue;
		}
		
		// check stop boundaries
		
		// -- for metadata
		if (ereg("</record>",$val)){
			$no++;
			$metadata_start = 0;
			
			$metadata_string = oaipmp_clear_badchars($metadata_string);
			$metadata_buff = "<record>$metadata_string</record>";
			$metadata_string = "";
			
			// import to database
			$import_result = import_providers($metadata_buff);
			$received_id .= "$import_result[id] ($import_result[status]); ";
		}
		

		// catch the data
		if ($metadata_start == 1){
			$metadata_string .= $val;
		}
		
		// *** resumption token
		if (ereg("<resumptionToken",$val)) $resumption_start = 1;
		if ($resumption_start == 1) $resumption_string .= $val;
		if (ereg("</resumptionToken>",$val)){
			$resumption_start = 0;
			$resumption_string = oaipmp_xmlheading()."<dc>$resumption_string</dc>";
			$resumption_xml = readXML($resumption_string);
			
			$results[token] = $resumption_xml[RESUMPTIONTOKEN][0];
			$results[total] = $resumption_xml["RESUMPTIONTOKEN.COMPLETELISTSIZE"][0];
			$results[cursor] = $resumption_xml["RESUMPTIONTOKEN.CURSOR"][0];
		}
		
	}
	
	if (empty($received_id)) $received_id = "Providers are uptodate.";	
	$results[count] = $no;
	$results[identifiers] = $received_id;
	
	return $results;

}

// ******************* RESPONSES ************************
// generate response
function oaipmh_generate_response($verb,$args,$elements)
{
	$res = oaipmp_xmlheading();
	$res .= oaipmh_xmlns();
	$res .= oaipmp_responseDate();
	$res .= oaipmp_request($verb,$args);
	$res .= oaipmh_element($elements);
	$res .= oaipmh_close();
	
	return $res;

}


// xmlns
function oaipmh_xmlns()
{
	$xmlns = "
<OAI-PMH xmlns=\"http://www.openarchives.org/OAI/2.0/\" 
      xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"
      xsi:schemaLocation=\"http://www.openarchives.org/OAI/2.0/
      http://www.openarchives.org/OAI/2.0/OAI-PMH.xsd\">";
   
   return $xmlns;	
}

// xmlns close
function oaipmh_close()
{
	$close = "
</OAI-PMH>";
	return $close;
}

// *************************** ELEMENTS ****************************


// select element to be returned
function oaipmh_element($elements)
{
	$verb = $elements[0];
	switch($verb){
		case "error":
			$response = oaipmp_element_error($elements[1],$elements[2]);
			break;
		case "ListIdentifiers":
			$response = oaipmh_element_response_ListIdentifiers($elements[1]);
			break;
		case "ListRecords":
			$response = oaipmh_element_response_ListRecords($elements[1]);
			break;
		case "ListProviders":
			$response = oaipmh_element_response_ListProviders($elements[1]);
			break;
		default:
			$response = oaipmp_element_error("badVerb","Unknown verb $verb");
	}
	
	return $response;
}

// element header
function oaipmh_element_header($status,$identifier,$datestamp,$setSpec)
{

	if ($status == "deleted") $element_status = "
       <status>deleted</status>";

	$header = "
    <header>$element_status
       <identifier>$identifier</identifier>
       <datestamp>$datestamp</datestamp>
       <setSpec>$setSpec</setSpec>
    </header>";
    
    return $header;
}

// element ListIdentifiers
function oaipmh_element_response_ListIdentifiers($element)
{
	return $element;
}

// element ListIdentifiers
function oaipmh_element_response_ListRecords($element)
{
	return $element;
}

// element ListIdentifiers
function oaipmh_element_response_ListProviders($element)
{
	return $element;
}

// element providerId
function oaipmh_element_providerId()
{
	global $HTTP_SESSION_VARS;
	
	$providerId = "
    <providerId>".$HTTP_SESSION_VARS[sess_providerId]."</providerId>";
	
	return $providerId;
}

// Invalid argument
function oaipmh_invalid_arguments($verb)
{
	global $_SERVER;
	
	$args = oaipmp_get_request();
	
	$str_args = join(', ',oaipmp_arguments($verb));
	$element = array("error", "badArgument", "Incomplete arguments. Required arguments: $str_args. ".
		"Received query string: ".wordwrap($_SERVER[QUERY_STRING],60," ",1));
	$response = oaipmh_generate_response($verb,$args,$element);
	
	return $response;
}
%>