<%
/***************************************************************************
                  oaiphp.php  -  function related to OAI PMP
                             -------------------
    begin                : Sept, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 

if (defined ('oaipmp_php')) { 
	return; 
} else { 
	define ('oaipmp_php', true); 
}

require_once "functions/xmlparser.php";
require_once "functions/import.php";
require_once "functions/client.php";


// ***************************** VERBS *************************************

// ********************* VERB = Connect ************************************


function oaipmp_response_Connect($providerId,$providerSerialNumber,$epochTime)
{
	global $_SERVER;
	
	$verb = "Connect";
	$args = oaipmp_get_request();
	
	// check argument
	if (!oaipmp_check_arguments($verb)){
		$response = oaipmp_invalid_arguments($verb);
		return $response;
	}
		
	// Check epochTime
	// if more than 1 day, it is invalid
	$now = date("U");
	$delta = $now - $epochTime;
	$oneday = (24 * 60 * 60);
	if ($delta >= $oneday){
		$element = array("error", "badEpochTime", "epochTime is longer than 1 day from my epochTime $now.");
		$response = oaipmp_generate_response($verb,$args,$element);
		return $response;
	}
	
	
	$strsql = "SELECT DC_PUBLISHER_SERIALNO,DC_PUBLISHER_NETWORK FROM publisher 
				WHERE DC_PUBLISHER_ID = '$providerId'";
	$dbres = mysql_query($strsql);
	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$validSerialNumber = mysql_result($dbres,0,"DC_PUBLISHER_SERIALNO");
			$providerNetwork = mysql_result($dbres,0,"DC_PUBLISHER_NETWORK");
			$mdString = "$validSerialNumber-$epochTime";
			$validSerialNumber = md5($mdString);
			if ($providerSerialNumber == $validSerialNumber){
				$elements = array("connect",$providerId,$providerNetwork);
				$response = oaipmp_generate_response($verb,$args,$elements);
				
				// success, create session
				oaipmp_create_session($providerId,$providerNetwork);
				
			} else {
				$elements = array("error", "badSerialNumber", "Invalid providerSerialNumber. 
					My calculation is $validSerialNumber");
				$response = oaipmp_generate_response($verb,$args,$elements);
			}
		} else {
			$elements = array("error", "noRecordsMatch", "providerId $providerId is not found.");
			$response = oaipmp_generate_response($verb,$args,$elements);
		}
	} else {
		$elements = array("error", "systemError", mysql_error());
		$response = oaipmp_generate_response($verb,$args,$elements);
	}
	
	echo $response;
	
	return;
}

// save connection session
function oaipmp_create_session($providerId,$providerNetwork)
{
	global $HTTP_SESSION_VARS;
	
	$HTTP_SESSION_VARS[sess_providerId] = $providerId;
	$HTTP_SESSION_VARS[sess_providerNetwork] = $providerNetwork;
	$HTTP_SESSION_VARS[sess_client_start] = date("Y/m/d h:i:s");
	
	return;
}

// check session
function oaipmp_check_session($verb)
{
	global $HTTP_SESSION_VARS;
	
	// check argument
	if (!oaipmp_check_arguments($verb)){
		return;
	} 
	
	if (empty($HTTP_SESSION_VARS[sess_providerId])) {
		$args = oaipmp_get_request();
		$elements = array("error","badSession","Server has lost connection. Please Connect again.");
		$response = oaipmh_generate_response($verb,$args,$elements);
		echo $response;
		
		return 0;
	} else {
		return 1;
	}
}

// ********************** VERB = PutListRecords ***************************

// The Request
function oaipmp_request_PutListRecords($resumptionToken)
{
	global $HTTP_SESSION_VARS,$conf;
	
	$limit = $conf[sync_count_records];
	
	// get metadata	
	$strsql = "SELECT metadata_xml.*,outbox.status,outbox.DATEMODIFIED FROM metadata_xml,outbox
			WHERE
				metadata_xml.IDENTIFIER = outbox.IDENTIFIER AND
				outbox.FOLDER = 'outbox'
			LIMIT 0,$limit
			";
	
	$dbres = mysql_query($strsql);
	if ($dbres){
		while ($row = mysql_fetch_array($dbres)){
			// generate elements
			$element_header = oaipmp_element_header($row[IDENTIFIER],$row[status],$row[DATEMODIFIED]);
			$element_metadata = oaipmp_element_metadata($row[XMLDATA]);
			$element_record = oaipmp_element_record($element_header,$element_metadata);
			
			$records .= $element_record;
		}
	}
	
	$request_elements = oaipmp_element_PutListRecords($records);
	
	// generate request 
	$request_data = oaipmp_generate_request($request_elements);
	
	$REQUEST = "verb=PutListRecords".
				"&PHPSESSID=".$HTTP_SESSION_VARS[sess_connect_sessionid].
				"&countRecords=$limit&resumptionToken=$resumptionToken";
				
	$URI = "http://$conf[sync_hub_server_name]/$conf[sync_oai_script]?$REQUEST";
		
	$DATA = "data=".urlencode($request_data);
		
	$HEADER = "POST $URI HTTP/1.0\r\n";
	$HEADER .= "Content-type: application/x-www-form-urlencoded\r\n"; 
	$HEADER .= "Content-length: " . strlen($DATA) . "\r\n\r\n"; 
	
	$request[HEADER] = $HEADER;
	$request[DATA] = $DATA;
	
	//echo "<p><h3>Request</h3> Header: $request[HEADER]";
	
	return $request;		
}

// The Response
function oaipmp_response_PutListRecords()
{
	global $data, $HTTP_SESSION_VARS;
	
	$verb = "PutListRecords";
	$args = oaipmp_get_request();
	
	// check argument
	if (!oaipmp_check_session($verb)){
		return 0;
	} else {
	
		// get the records
		$size = strlen($data);
		$data = stripslashes(urldecode($data));
	
		// extract the records
		$put_result = oaipmp_extract_record($data,"inbox");
	
		// generate response
		$elements = array("PutListRecords",$HTTP_SESSION_VARS[sess_providerId],$put_result[count],
					$size,$put_result[identifiers]);
		$response = oaipmp_generate_response($verb,$args,$elements);
	}
	
	// send response
	echo $response;
}

// ***************************************************
// 			Arguments

// Define arguments
function oaipmp_arguments($verb)
{
	switch($verb){
		case "Connect":
			$args = array("verb","providerId","providerSerialNumber","epochTime");
			break;
		case "PutListRecords":
			$args = array("verb","PHPSESSID","countRecords","resumptionToken");
			break;
		
		// ******** OAI
		case "ListIdentifiers":
			$args = array("verb","PHPSESSID","set");
			break;
		case "ListRecords":
			$args = array("verb","PHPSESSID","set","from","limit","resumptionToken");
			break;
		case "ListProviders":
			$args = array("verb","PHPSESSID","limit","resumptionToken");
			break;
		Default:
			$args = array("verb");
	}
	return $args;
}

// Check argument
function oaipmp_check_arguments($verb)
{
	$check = 0;
	
	$args = oaipmp_arguments($verb);
	$check = oaipmp_compare_arguments($args);

	if ($check){
		return 1;
	} else {
		echo oaipmh_invalid_arguments($verb);	
		return 0;
	}
}

// Compare argument
function oaipmp_compare_arguments($args)
{
	$sent_args = oaipmp_get_arguments();
	$diff = array_diff($args,$sent_args);
	
	/*
	print_r($args);
	print_r($sent_args);
	print_r($diff);
	*/
	
	if (sizeof($diff)>0){
		return 0;
	} else {
		return 1;
	}
}

// Invalid argument
function oaipmp_invalid_arguments($verb)
{
	global $_SERVER;
	
	$args = oaipmp_get_request();
	
	$str_args = join(', ',oaipmp_arguments($verb));
	$element = array("error", "badArgument", "Incomplete arguments. Required arguments: $str_args. Received query string: $_SERVER[QUERY_STRING].");
	$response = oaipmp_generate_response($verb,$args,$element);
	
	return $response;
}

// Get arguments
function oaipmp_get_arguments()
{
	global $_SERVER;
	
	$query = $_SERVER[QUERY_STRING];
	$ar = explode("&",$query);
	$args = array();
	foreach($ar as $val){
		$pos = strpos($val,"=");
		if (is_integer($pos)){
			$arg = substr($val,0,$pos);
			array_push($args,$arg);
		}
	}
	return $args;
}

// Get arguments and value request
function oaipmp_get_request()
{
	global $_SERVER;
	
	$query = $_SERVER[QUERY_STRING];
	$ar = explode("&",$query);

	foreach($ar as $val){
		$pos = strpos($val,"=");
		if (is_integer($pos)){
			$arg = substr($val,0,$pos);
			$value = substr($val,$pos+1);
			$args[$arg] = $value;
		}
	}
	return $args;
}

// ************************* REQUESTS *********************

// generate request
function oaipmp_generate_request($request_elements)
{
	$res = oaipmp_xmlheading();
	$res .= "\n".oaipmp_xmlns();
	$res .= "\n".oaipmp_requestDate();
	$res .= "\n".$request_elements;
	$res .= "\n".oaipmp_close();
	
	return $res;

}



// ************************* RESPONSES ********************

// generate response
function oaipmp_generate_response($verb,$args,$elements)
{
	$res = oaipmp_xmlheading();
	$res .= oaipmp_xmlns();
	$res .= oaipmp_responseDate();
	$res .= oaipmp_request($verb,$args);
	$res .= oaipmp_element($elements);
	$res .= oaipmp_close();
	
	return $res;

}


// ************** extract records ******************

function oaipmp_extract_record($data,$box)
{
	$arr_data = explode("\n",$data);
	
	//echo $data;
	
 	$results[size] = strlen($data);
	
	$record_start = 0;
	$record_string = "";
	$no = 0;
	$need_update = TRUE;
	
	while(list($key,$val) = each($arr_data)){
		
		// check start boundaries
		if (ereg("<header>",$val)) {
			$record_start = 1;
			continue;
		}
		
		if (ereg("<metadata>",$val)) {
			$metadata_start = 1;
			continue;
		}
		
		// check stop boundaries
		
		// -- for metadata
		if (ereg("</metadata>",$val)){
			$metadata_start = 0;
			
			$metadata_string = oaipmp_clear_badchars($metadata_string);
			$metadata_buff = $metadata_string;
			$metadata_string = "";

			// import to database
			if ($need_update[update]){
				$import_result = import_metadata($metadata_buff,$need_update[status],$box);
				$received_id .= "$identifier ($import_result[status]); ";
			} else {
			 	$received_id .= "$identifier (*); ";
			}	
		}
		
		// -- for header
		if (ereg("</header>",$val)) {
			$no++;
			$record_start = 0;
			
			// read header
			$header_xmldata = "<dc><header>$record_string</header></dc>";
			$xml = readXML($header_xmldata);
			
			// get header information
			$identifier = $xml["HEADER.IDENTIFIER"][0];
			$datestamp = $xml["HEADER.DATESTAMP"][0];
			$status = $xml["HEADER.STATUS"][0];

			
			// compare datestamp
			$need_update = oaipmp_is_record_need_update($identifier,$datestamp,$box);

			
			// flush the buffer
			$record_string = "";
			
			if ($status == "deleted"){
				// update database
				$import_result = import_metadata($header_xmldata,$status,$box);
				$received_id .= "$identifier (deleted); ";
				oaipmp_delete_metadata_collection($identifier);
			}
		}

		// catch the data
		if ($record_start == 1){
			$record_string .= $val;
		}
		
		if ($metadata_start == 1){
			$metadata_string .= $val;
		}
		
		// *** resumption token
		if (ereg("<resumptionToken",$val)) $resumption_start = 1;
		if ($resumption_start == 1) $resumption_string .= $val;
		if (ereg("</resumptionToken>",$val)){
			$resumption_start = 0;
			$resumption_string = oaipmp_xmlheading()."<dc>$resumption_string</dc>";
			$resumption_xml = readXML($resumption_string);
			
			$results[token] = $resumption_xml[RESUMPTIONTOKEN][0];
			$results[total] = $resumption_xml["RESUMPTIONTOKEN.COMPLETELISTSIZE"][0];
			$results[cursor] = $resumption_xml["RESUMPTIONTOKEN.CURSOR"][0];
		}
		
	}
	
	if (empty($received_id)) $received_id = "Metadata are uptodate.";	
	$results[count] = $no;
	$results[identifiers] = $received_id;
	
	return $results;
	
}

// compare datestamp
function oaipmp_is_record_need_update($identifier,$datestamp,$box)
{

	$strsql = "SELECT $box.DATEMODIFIED,$box.FOLDER,metadata.STATUS FROM $box,metadata
					WHERE metadata.IDENTIFIER = '$identifier' AND
						$box.IDENTIFIER = metadata.IDENTIFIER";

	$dbres = mysql_query($strsql);

	if ($dbres){
		if (mysql_num_rows($dbres)>0){
			$mydate = mysql_result($dbres,0,"DATEMODIFIED");
			$folder = mysql_result($dbres,0,"FOLDER");
			$status = mysql_result($dbres,0,"STATUS");
	
			if ($status == "deleted"){
				$res[update] = 1;
				$res[status] = "update";
			} else if ($folder == $box){
				$res[update] = 1;
				$res[status] = "update";
			} else if ($mydate < $datestamp){
				$res[update] = 1;
				$res[status] = "update";
			} else {
				$res[update] = 0;
				$res[status] = "uptodate";
			}
		} else {
			$res[update] = 1;
			$res[status] = "new";
		}
	} else {
		echo mysql_error();
		$res[update] = 0;
		$res[status] = "uptodate";
	}
	
	return $res;
}

// delete metadata_xml
function oaipmp_delete_metadata_collection($identifier)
{
	$strsql = "UPDATE metadata_xml SET XMLDATA = 'deleted' WHERE IDENTIFIER = '$identifier'";
	$dbres = mysql_query($strsql);
	return;
}

// *************************** ELEMENTS ****************************


// select element to be returned
function oaipmp_element($elements)
{
	switch($elements[0]){
		case "connect":
			$response = oaipmp_element_connect($elements[1],$elements[2]);
			break;
		case "error":
			$response = oaipmp_element_error($elements[1],$elements[2]);
			break;
		case "PutListRecords":
			$response = oaipmp_element_response_PutListRecords($elements[1],$elements[2],$elements[3],
				$elements[4]);
			break;
	}
	
	return $response;
}

// xml heading
function oaipmp_xmlheading()
{
	$xmlheading = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
	return $xmlheading;
}

// xmlns
function oaipmp_xmlns()
{
	$xmlns = "
<OAI-PMP xmlns=\"http://www.indonesiadln.org/OAI/1.0/\" 
      xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"
      xsi:schemaLocation=\"http://www.indonesiadln.org/OAI/1.0/
      http://www.indonesiadln.org/OAI/1.0/OAI-PMP.xsd\">";
   
   return $xmlns;
	
}

// xmlns close
function oaipmp_close()
{
	$close = "
</OAI-PMP>";
	return $close;
}

// responseDate
function oaipmp_responseDate()
{
	$ymd = date("Y-m-d");
	$his = date("H:i:s");
	$responseDate = 	"
    <responseDate>".$ymd."T".$his."Z</responseDate>";
	
	return $responseDate;
}

// requestDate
function oaipmp_requestDate()
{
	$ymd = date("Y-m-d");
	$his = date("H:i:s");
	$requestDate = 	"
 <requestDate>".$ymd."T".$his."Z</requestDate>";
	
	return $requestDate;
}

// request
function oaipmp_request($verb,$args)
{
	global $_SERVER,$HTTP_SESSION_VARS;
	
	if (empty($HTTP_SESSION_VARS[sess_providerId])){	
		$requester = "Unknown";
	} else {
		$requester = $HTTP_SESSION_VARS[sess_providerId];
	}
	
	$request = "
    <request 
        requesterId=\"$requester\"";
	while (list($key,$val) = each($args)){
		$request .= "\n        $key=\"$val\"";
	}
	$request .= ">http://$_SERVER[SERVER_NAME]$_SERVER[PATH_INFO]</request>";
	
	return $request;
}


// element connect
function oaipmp_element_connect($providerId,$providerNetwork)
{
	$connect = "
      <Connect>
          <sessionId>".session_id()."</sessionId>
          <providerId>$providerId</providerId>
          <providerNetwork>$providerNetwork</providerNetwork>
      </Connect>";
	
	return $connect;
}

// Formatting error code
function oaipmp_element_error($code,$string)
{
	$err = "
    <error code=\"$code\">$string</error>";
	return $err;
}

// element record header
function oaipmp_element_header($identifier,$status,$datestamp)
{
	
	$header = "
<header>
  <identifier>$identifier</identifier>
      <status>$status</status>
      <datestamp>$datestamp</datestamp>
</header>";

	return $header;
}

// element metadata
function oaipmp_element_metadata($xmldata)
{

	$metadata = "
<metadata>
		$xmldata
    </metadata>";
       
 	return $metadata;      
}

// element oai_dc
function oaipmp_element_oai_dc()
{
	$oaidc = "
      <oai_dc:dc
             xmlns:oai_dc=\"http://www.openarchives.org/OAI/2.0/oai_dc/\"   
             xmlns:dc=\"http://purl.org/dc/elements/1.1/\" 
             xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" 
             xsi:schemaLocation=\"http://www.openarchives.org/OAI/2.0/oai_dc/ 
             http://www.openarchives.org/OAI/2.0/oai_dc.xsd\"> ";
    
    $oaidc2 = "<dc>";
    
    return $oaidc2;
}

// element oai_dc
function oaipmp_element_oai_idln()
{
	$oai_idln = "
      <oai_idln:dc
             xmlns:oai_idln=\"http://www.indonesiadln.org/OAI/1.0/oai_idln/\"   
             xmlns:dc=\"http://purl.org/dc/elements/1.1/\" 
             xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" 
             xsi:schemaLocation=\"http://www.indonesiadln.org/OAI/1.0/oai_idln/ 
             http://www.indonesiadln.org/OAI/1.0/oai_idln.xsd\"> ";
    
    $oai_idln2 = "<dc>";
    
    return $oai_idln2;
}

// element record
function oaipmp_element_record($header,$metadata)
{
	$record = "
<record>
 $header
    $metadata
  </record>";
    
	return $record;
}

// element PutListRecords
function oaipmp_element_PutListRecords($element_records)
{
$putlistrecords = "
 <PutListRecords>
      $element_records
 </PutListRecords>";
 
 return $putlistrecords;
}

// element response PutListRecords
function oaipmp_element_response_PutListRecords($providerId,$count,$size,$identifiers)
{
	global $countRecords;
	
	if (empty($providerId)){
		$error[1] = "
       <error code=\"badSession\">Disconnected from the hub server. Please reconnect.</error>";	
	}
	
	if ($countRecords != $count){
		$error[2] = "
       <error code=\"badCountRecords\">Number of records received ($count) by hub server doesn't match with countRecords ($countRecords).</error>";
	}
	
	if (!empty($error[1])) $identifiers = "";
	
	$putlistrecords = "
    <PutListRecords>
       <countRecords>$count</countRecords>$error[2]
       <size>$size</size>
       <identifiers>$identifiers</identifiers>
    </PutListRecords>";
	
	return $putlistrecords;
}

// ****************** FILE SYSTEM AND STRING ***************

// check directory 
function oaipmp_check_dir($dirname)
{
	if (file_exists($dirname)){
		return 1;
	} else {
		if (@mkdir($dirname,0755)){
			return 1;
		} else {
			return 0;
		}
	}
}

// clearing bad characters
function oaipmp_clear_badchars($xmldata)
{
	//clearing character 
	
	$xmldata = str_replace("","(c)",$xmldata);
	
	return $xmldata;
}
%>