<%
/***************************************************************************
                          bookmark.php  -  function related to bookmark
                             -------------------
    begin                : Aug 23, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
if (defined ('search_php')) { 
	return; 
} else { 
	define ('search_php', true); 
}

require_once "functions/xmlparser.php";
require_once "functions/metadata.php";
require_once "functions/string.php";


// Function to generate search command
function search_cmd($file_index,$start){
	global $str_query, $q, $frm;

	if (is_array($frm)){
		$str_query = search_query_advanced($frm);
	} else {		
		$str_query = search_query_quick($q);
	}
	
	if (empty($start)) $start = 1;
	
	$str_cmd = ".\bin\swishe.exe -f $file_index -b $start -w \"$str_query\"";
	
	//echo $str_cmd;
	
	$cmd = `$str_cmd`;
	
	return $cmd;
	
}

// Function for quick search
function search_query_quick($q){

	$str = clean_query($q);
	if (ereg("\"",$q)){
		$query = "dc = $str";
	} else {
		$query = "dc = ($str)";
	}
	server_log("search_qck","$q");
	
	return $query;
	
}

// Function for advanced search
function search_query_advanced($frm)
{
	global $s;
	
	while (list($key,$val) = each($frm[q])){
		if (!empty($val)){
			$metaname = $frm[TAG][$key];

			$word .= " $bool $metaname = ($val) ";
			
			$bool = $frm[BOL][$key];
		}
	}
	if ($s == "dc_article") 
		$schema = "dc_article or general or simple";
	else
		$schema = $s;
		
	$query = "schema = ($schema) AND $word ";
	server_log("search_adv","$query");
	return $query;
}


// Function to clean up query
function clean_query($q){

	$str = str_replace(";","",$q);
	$str = str_replace("&","",$str);
	$str = str_replace("\"","\\\"",$str);

	return $str;
}

// function to process search result
function search_process($cmd){
	global $q, $frm;
	global $str_query, $start;
	global $t, $l, $conf;
	
	include "schemas/type.inc";
	
	$res = explode("\n",$cmd);

	if (empty($start)) $start = 1;
	$perpage = $conf[perpage_search];
	
	if (is_array($frm)) $q = trim(join(' ',$frm[q]));
	
	for ($i = 0;$i< sizeof($res);$i++){
		//echo $res[$i]."<br>";
		$f = explode(" ",$res[$i]);
		$s = explode("\"",$res[$i]);
		
		if (eregi("no results",$res[$i])){
			if (is_array($frm)){
				$str_nomatch = $str_query;
			} else {
				$str_nomatch = $q;
			}
			
			echo "<h3>Search Result</h3>
				<p>$l[nomatch] <b>$str_nomatch</b>.</p>";
			$noresult = TRUE;
		} elseif ($f[0] == "err:"){
			echo "<blockquote><b>$res[$i]</b></blockquote>";
			$noresult = TRUE;
		} elseif (($f[0] != "#")&&($f[2] != "")){
			$no++;
			if ($no <= $perpage) {
			
				$nomor = $no + $start -1;
				
				// Get ID 
				$id = $f[1];
				
				// XML				
				$xml = metadata_read_db($id);
				
				$result_display = "schemas/search/result_".strtolower($xml[TYPE_SCHEMA]).".inc";

				if (file_exists($result_display)){
					include $result_display;
				} else {
					include "schemas/search/result_default.inc";
				}
				
			}
		} else {
			
			if (eregi("hits",$res[$i])){
				
				$all = $f[4];
				$res_end = $start+$perpage-1;
              if ($res_end > $all) $res_end = $all;
				
				if (is_array($frm)){
					$qry = $str_query;
				} else {
					$qry = $q;
				}
				
				echo "<table width=100% cellpadding=2 cellspacing=0 border=0 bgcolor=$t[color_dark]>
					<tr><td><font color=#ffffff>$l[search_for]: <b>$qry</b></font></td>
					<td align=right nowrap><font color=#ffffff size=1>Result <b>$start - $res_end</b> of about <b>$all</b>. ";
			}
			if (eregi("run time",$res[$i])){
				echo "<br>Search took <b>$f[3]</b> $f[4].</font></td></tr></table>";
			}

		}
	} // end for
	
	if (!$noresult){
		result_page($all,$perpage);
		return $all;
	} else {
		return 0;
	}
}


// Function to print result pages
function result_page($all,$perpage){
	global $q,$frm;

	$start = $_GET[start];
	if (empty($start)) $start = 1;
	
	echo "<p><table align=center>
	 <tr>
		<td>Result page:</td>
		<td></td>";
	
	$baseurl = "/search.php?";
	if (is_array($frm)){
		$query = $_SERVER[QUERY_STRING];
		if (ereg("start",$query)){
			$start_pos = strpos($query,"&start");
			$query = substr($query,0,$start_pos);
		}
		$baseurl .= "$query";
	} else {
		$baseurl .= "q=".urlencode($q);
	}
	
	for ($i=1;$i <= ceil($all/$perpage);$i++){
		if ((($i-1)*$perpage+1) == $start){
			echo "<td align=center><a href=$baseurl&start=".($perpage*($i-1)+1)."><font color=#FF0000><b>$i</b></font></a></td>";
		} else {
			echo "<td align=center><a href=$baseurl&start=".($perpage*($i-1)+1).">$i</a></td>";
		}
		if ($i == 10) {
			break;
		}
	}
	
	if (($all > $perpage) && (($start+$perpage-1) < $all)){
		echo "<td align=center><a href=$baseurl&start=".($start+$perpage)."><b>Next</a></b></td>";
	}
	echo "</tr></table>";

	return;
}

// Search advanced tab
function search_advance_tab()
{
	global $conf,$t,$s,$l,$search_tab;
	
	$lang = $conf[langid];
	
	// coloring
	if (empty($s)){
		$bg[all] = $t[color_dark];
		$fnt[all][1] = "<font color=#FFFFFF><b>";
		$fnt[all][2] = "</b></font>";
	} else {
		$bg[$s] = $t[color_dark];
		$fnt[$s][1] = "<font color=#FFFFFF><b>";
		$fnt[$s][2] = "</b></font>";
	}
	
	
	$space = "<img src=/images/dot.gif height=1 width=8>";
	
	reset ($search_tab[schema]);
	
	while (list($key,$val) = each($search_tab[schema])){
		$tab_schema = $val;
		$tab_title = $search_tab[title][$tab_schema][$lang];
		
		$link_1 = "<a href=/search.php?s=$tab_schema>";
		$link_2 = "</a>";
		
		if (empty($bg[$tab_schema])){	
			$bg[$tab_schema] = $t[color_light];
			$fnt[$tab_schema][1] = "<font color=$t[color_dark]>";
			$fnt[$tab_schema][2] = "</font>";
		} 
		
		$td .= "
			<td bgcolor=$bg[$tab_schema]>".
				$space.$link_1.$fnt[$tab_schema][1].$tab_title.$fnt[$tab_schema][2].$link_2.$space.
			"</td>";
	}
	
	echo "<p>
		<table width=100% boder=0 cellspacing=0 cellpadding=0>
			<tr>
				<td>
					<table><tr nowrap>$td</tr></table>
				</td>
			</tr>
			<tr>
    			<td><img border=0 src=images/dot_blue.gif height=1 width=100% ></td>
  			</tr>
		</table></p>
		";
}

// Show form
function search_show_form($s)
{
	global $l,$search_tab,$q;
	
	switch ($s){
		case "all":
		case "":
			include "forms/form_search.inc";
			break;
		default:
			$search_form = search_generate_form($s);
			echo $search_form;		
	}
}

// Generate form
function search_generate_selection($s,$no)
{
	global $search_tab,$conf,$frm;
	
	$lang = $conf[langid];
	
	reset ($search_tab[metaname][$s][tg]);
	
	while (list($key,$val) = each($search_tab[metaname][$s][tg])){
		$tag = $val;
		$tag_desc = $search_tab[metaname][$s][$lang][$key];
		
		// set selected
		if (!is_array($frm)){
			if ($key == $no) 
				$selected = "selected";
			else
				$selected = "";
		} else {
			if ($tag == $frm[TAG][$no]){
				$selected = "selected";
			} else {
				$selected = "";
			}
		}
		
		$options .= "<option $selected value=$tag>$tag_desc</option>";
	}
	
	$select = "<select size=1 name=frm[TAG][]>$options</select>";
	
	return $select;
	
}

// Index info
function search_index_info()
{
	$index_file = "bin/gdl40.idx";
	$mtime = filemtime($index_file);
	$mtime = date("Y-m-d H:i:s",$mtime);
	
	$idx[file] = $index_file;
	$idx[mtime] = $mtime;
	
	return $idx;
}

// Generate form
function search_generate_form($s)
{
	global $search_tab,$conf,$frm;
	
	$lang = $conf[langid];
		
	reset ($search_tab);
	$num = sizeof($search_tab[metaname][$s][tg]);
	
	for ($i=0;$i<$num;$i++){
		// generate select
		$select = search_generate_selection($s,$i); 	
		
		// generate and or 
		$bol = $frm[BOL][$i];
		if ($bol == "OR"){
			$sel_o = "selected";
			$sel_a = "";
		} else {
			$sel_o = "";
			$sel_a = "selected";
		}
		$andor = "
		<select size=1 name=frm[BOL][]>
			<option $sel_a value=AND>AND</option>
			<option $sel_o value=OR>OR</option>
		</select>";
		
		// generate search form
		$search .= "$select <input type=text size=40 name=frm[q][] value=\"".$frm[q][$i]."\" >$andor<br>";
	}
	
	if (!empty($search_tab[note][$s][$lang])){
		$note = "<br><font size=1>".wordwrap($search_tab[note][$s][$lang],80,"<br>")."</font><br>";
	}
	
	$form = "
		<form method=GET action=/search.php>
			<input type=hidden name=s value=$s>
			$search
			$note
			<br><input type=submit name=B value=Search><input type=reset name=B value=Reset>
		</form>";
	
	return $form;
}

// FUnction to create search log
function server_log($activities,$item){
	global $q;
	global $conf;
	global $HTTP_SERVER_VARS;
	
	if ($conf[SERVER_LOG]){	
		$user = $_SESSION[user][email];
		if (empty($user)) $user = "guest";
	
		$date = date("Y-m-d H:i:s");
		$logmsg = "$date $conf[INSTITUTION] $user $HTTP_SERVER_VARS[REMOTE_ADDR] $activities: $item \n";
	
		$fp = fopen($conf[SERVER_FILE],"a");
		fputs ($fp,$logmsg);
		fclose($fp);
	}
	
	return;

}


%>
