<%
/***************************************************************************
                          sessions.php  -  function related to session processing
                             -------------------
    begin                : June 14, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 

if (defined ('sessions_php')) { 
	return; 
} else { 
	define ('sessions_php', true); 
}

require_once "functions/explorer.php";
require_once "functions/metadata.php";

// Init session
function session_init()
{
	global $DC_PUBLISHER_ID;
	global $HTTP_SESSION_VARS;
	
	session_register("sess_email","sess_username","sess_orgname",
		"sess_origin","sess_gid","sess_explorer_pane");

	$HTTP_SESSION_VARS["sess_email"] = "guest";
	$HTTP_SESSION_VARS["sess_username"] = "Guest";
	$HTTP_SESSION_VARS["sess_orgname"] = "Public";
	$HTTP_SESSION_VARS["sess_origin"] = $DC_PUBLISHER_ID;
	$HTTP_SESSION_VARS["sess_gid"] = "0"; // group user
	$HTTP_SESSION_VARS["sess_explorer_pane"] = 1;
	
	return;
}

// Init Language
function session_init_lang($lang)
{
	global $HTTP_SESSION_VARS;
	
	if (!isset($HTTP_SESSION_VARS[sess_langid])) session_register("sess_langid");
	$HTTP_SESSION_VARS[sess_langid] = $lang;
	
	return;
}

// Function to create new session for user
function session_create($email, $username, $orgname, $origin, $gid)
{
	global $HTTP_SESSION_VARS;
	
	session_register("sess_email","sess_username","sess_orgname","sess_origin","sess_gid");
	
	$HTTP_SESSION_VARS["sess_email"] 	= $email;
	$HTTP_SESSION_VARS["sess_username"] 	= $username;
	$HTTP_SESSION_VARS["sess_orgname"] 	= $orgname;
	$HTTP_SESSION_VARS["sess_origin"] 		= $origin;
	$HTTP_SESSION_VARS["sess_gid"] 		= $gid;
	
	return;
}

// brose
function session_init_browse()
{
	global $HTTP_SESSION_VARS, $node, $exp, $id,$start, $view;
	
	$mynode = $node;
	
	if (!isset($HTTP_SESSION_VARS["sess_explorer_address"]))
		session_register("sess_explorer_address","sess_upload_id");
	
	if (isset($id)){
		$mynode = metadata_parent($id);
		$HTTP_SESSION_VARS[sess_explorer_address][0] = $mynode;
		$HTTP_SESSION_VARS[sess_upload_id] = $id;
		
	}	elseif ( (explorer_folder_numchild($mynode) > 0) || (explorer_folder_nummeta($mynode)>0) )	
	{	
	
		if (isset($mynode) && ($exp != 1) ){
			$HTTP_SESSION_VARS[sess_explorer_address][0] = $mynode;
		}

	} elseif ($mynode == 0){
		$HTTP_SESSION_VARS[sess_explorer_address][0] = $mynode;
	}
	
	if (isset($start)) {
		if (!isset($HTTP_SESSION_VARS["sess_explorer_start"]))
			session_register("sess_explorer_start");
			
		$HTTP_SESSION_VARS[sess_explorer_start] = $start;

	} elseif (isset($node)){
		$HTTP_SESSION_VARS[sess_explorer_start] = 1;
		$HTTP_SESSION_VARS[sess_explorer_address_up][0] = $node;
		$HTTP_SESSION_VARS[sess_explorer_address][0] = $node;
	}

	if (isset($view) || !isset($HTTP_SESSION_VARS[sess_view])){
		session_register("sess_view");
		if (isset($view)){
			$HTTP_SESSION_VARS[sess_view] = $view;
		} else {
			$HTTP_SESSION_VARS[sess_view] = "title";
		}
	}
	
	return;
}


// Init explorer
function session_init_explorer()
{
	global $HTTP_SESSION_VARS, $a, $b, $w, $p, $address, $id, $shid;

	if (empty($HTTP_SESSION_VARS[sess_username])){
		session_init();
		return;
	}

	if (!isset($HTTP_SESSION_VARS["sess_explorer_pane"]))
		session_register("sess_explorer_pane");
	
	if (!empty($p)) {
		$HTTP_SESSION_VARS[sess_explorer_pane] = $p;
		if (($p == 1) && ($w == 1)){
			$HTTP_SESSION_VARS[sess_explorer_address][0] = $HTTP_SESSION_VARS[sess_explorer_address][1];
			$HTTP_SESSION_VARS[sess_explorer_address_up][0] = $HTTP_SESSION_VARS[sess_explorer_address_up][1];
		}
	} else {
		if ($w == 1){
			$HTTP_SESSION_VARS[sess_explorer_pane] = 2;
		}
	}

	
	// retain the session while editing	
	if ($b == "edit") return;
	
	// set session
	
	if (!isset($HTTP_SESSION_VARS["sess_explorer_address"]))
		session_register("sess_explorer_address");
	
	if (!isset($HTTP_SESSION_VARS["sess_explorer_address_up"])){
		session_register("sess_explorer_address_up");
		$HTTP_SESSION_VARS["sess_explorer_address_up"][$w] = 0;
	}
		
	if (!isset($HTTP_SESSION_VARS["sess_explorer_a"]))
		session_register("sess_explorer_a");
		
	if (!isset($HTTP_SESSION_VARS["sess_explorer_b"]))
		session_register("sess_explorer_b");
	
	// select target
	if (isset($address)){
		$target = explorer_pname_to_node($address);
		$node = $target[NODE];
		$w = 0;
		$b = "open";
		
	} else {
		$node = $a;
	}
	
	// set the value
	
	$HTTP_SESSION_VARS[sess_explorer_address][$w] = $node;
	$HTTP_SESSION_VARS[sess_explorer_address_up][$w] = explorer_address_up($node);

	
	$HTTP_SESSION_VARS[sess_explorer_a][$w] = $node;
	$HTTP_SESSION_VARS[sess_explorer_b][$w] = $b;
	
	// show child number?
	if (isset($_GET[c])){
		session_register("sess_explorer_count_child");
		$HTTP_SESSION_VARS[sess_explorer_count_child] = $_GET[c];
	}
	
	// show id or title
	if (!empty($shid)){
		$HTTP_SESSION_VARS[sess_explorer_shid] = $shid;
	}
	
	return;

}

// set init session for upload
function session_init_upload()
{
	global $HTTP_SESSION_VARS, $a, $node, $w, $frm, $type, $id, $step, $form_action;
	
	// init session
	if (!isset($HTTP_SESSION_VARS[sess_upload_address]))
		session_register("sess_upload_address","sess_upload_window");
	
	// node
	
	if (isset($a)){
		if (explorer_folder_iswrite("folder",$a)){
			$HTTP_SESSION_VARS[sess_upload_address] = $a;
			$HTTP_SESSION_VARS[sess_upload_window] = $w;
		} else {
			// home dir or temporary
			session_init_upload_default();
		}
	} elseif (isset($node)){
		$HTTP_SESSION_VARS[sess_upload_address] = $node;
	} elseif ($HTTP_SESSION_VARS[sess_explorer_address][0] < 1){
		session_init_upload_default();
	} elseif (explorer_folder_iswrite("folder",$HTTP_SESSION_VARS[sess_explorer_address][0])){
		$HTTP_SESSION_VARS[sess_upload_address] = $HTTP_SESSION_VARS[sess_explorer_address][0];
		
	} else {
		// home dir or temporary
		session_init_upload_default();
	}
	
	if ($form_action == "ADD")	$id = metadata_generate_identifier();
	if (ereg("\?\?",$id)) $id = "";
	
	
	if (!empty($id) && ($step == 1)){
		if (!isset($HTTP_SESSION_VARS[sess_upload_address]))
			session_register("sess_upload_type","sess_upload_id");
		$minfo = metadata_info($id);
		$HTTP_SESSION_VARS[sess_upload_type] = $minfo[SCHEMA];
	}
	
	// store id
	if ($step == 2) {
		if (empty($type)) $type = "general";
		$HTTP_SESSION_VARS[sess_upload_type] = $type;
		$HTTP_SESSION_VARS[sess_upload_id] = $id;
	
	} elseif (!empty($frm[IDENTIFIER])){
		$HTTP_SESSION_VARS[sess_upload_id] = $frm[IDENTIFIER];
	}
	
	// store orgname
	if (!empty($frm[CREATOR_ORGNAME_NEW])){
		session_register("sess_upload_orgname_new");
		$HTTP_SESSION_VARS[sess_upload_orgname_new] = $frm[CREATOR_ORGNAME_NEW];
	}
	
	return;
}

// upload default
function session_init_upload_default()
{
	global $HTTP_SESSION_VARS,$a,$w;

		if (isset($a)){
			$target_node = $a;
		} else {
			$target_node = $HTTP_SESSION_VARS[sess_explorer_address][0];
		}
		
		if (($target_node < 1) || ($HTTP_SESSION_VARS[sess_gid] == 0)) {
			$tmp = explorer_pname_to_node("/Temporary/");
			$HTTP_SESSION_VARS[sess_upload_address] = $tmp[NODE];
			
		} elseif ($HTTP_SESSION_VARS[sess_gid] == 4) {
			$home = explorer_pname_to_node("/Member/$HTTP_SESSION_VARS[sess_email]");
			$home_path = explorer_path($home[NODE],0);

			$upload_path = explorer_path($target_node,0);

			if (ereg($home_path[NODE],$upload_path[NODE])){
				$HTTP_SESSION_VARS[sess_upload_address] = $target_node;
			} else {		
				$HTTP_SESSION_VARS[sess_upload_address] = $home[NODE];
			}

		} else {
			$tmp = explorer_pname_to_node("/Temporary/");
			$HTTP_SESSION_VARS[sess_upload_address] = $tmp[NODE];
		}
		
	return;
}

// write log
function session_logging()
{
	global $_SERVER, $HTTP_SESSION_VARS, $_COOKIE;
	
	$datestamp = date("Y-m-d H:i:s");
	$sessid = $_COOKIE[PHPSESSID];
	$ipaddress = $_SERVER["REMOTE_ADDR"];
	$user	= $HTTP_SESSION_VARS["sess_email"];
	$publisher = $HTTP_SESSION_VARS["sess_origin"];
	$url = $_SERVER["REQUEST_URI"];
	
	$strsql = "INSERT INTO access_log (DATESTAMP, PHPSESSID, IPADDRESS, USER, PUBLISHER, URL)
					VALUES ('$datestamp','$sessid','$ipaddress','$user','$publisher','$url')";
	
	$dbres = mysql_query($strsql);
	if (!$dbres) stdout_error("session_logging(): ".mysql_error());
	return;
	
}

%>