<%
/***************************************************************************
                          upload.php  -  function related to upload processing
                             -------------------
    begin                : June 14, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 

if (defined ('upload_php')) { 
	return; 
} else { 
	define ('upload_php', true); 
}

require_once "functions/explorer.php";
require_once "functions/metadata.php";
require_once "functions/db.php";


// Upload header
function upload_header()
{
	global $l;
	
	$modupload = TRUE;
   	
	echo "<h3>$l[upload_header]</h3>";

	return;
}

// Upload metadata into database
function upload_metadata()
{
	global $frm, $form_action;

	// generate metadata
	$xml_metadata = metadata_generate_xml($form_action);
	
	// generate relation
	if (!empty($frm[IDENTIFIER]) && ($form_action != "ADD")){
		// append relation
		if ($frm[RELATION_COUNT]>0){
			$xml_rel = metadata_generate_relation($frm[IDENTIFIER],$frm[RELATION_COUNT]);
			$xml_metadata = str_replace("<relation>#RELATION_EXTERNAL_ENTITIES#</relation>",$xml_rel,$xml_metadata);
		} else {
			$xml_metadata = str_replace("<relation>#RELATION_EXTERNAL_ENTITIES#</relation>","",$xml_metadata);
		}
	}
	
	// Add

	if ($form_action == "ADD"){
		$upload_res = db_metadata_insert($xml_metadata);
	
	// Update
	
	} elseif ($form_action == "UPDATE"){
		$upload_res = db_metadata_update($frm[IDENTIFIER],$xml_metadata);
	}
	
	return $upload_res;
}

// Store to db
function upload_save()
{
		
	$mod_form = "forms/form_upload_".$type.".inc";
	$mod_validation_file = "forms/form_upload_".$type."_validate.inc";
			
	if (file_exists($mod_validation_file)){

		// Check the form 
		if (form_is_valid($frm,$mod_validation_file)){
			
			// insert into database
			
			$upload_res = upload_metadata();
			
		} 

	} else {
		$errmsg = "Error: File <b>$mod_form_validate</b> $e[notfound]";
	}

}

// upload files
function upload_file()
{
	global $frm,$id,$l,$HTTP_POST_FILES;
	
	switch($frm[RELATION_BTN]){
		case "Change":
			if (metadata_change_relation_count($id,$frm[RELATION_COUNT])){
				stdout_error("Number of files is changed.");		
				// update relation in metadata
				//metadata_relation_append($id);	
			}

			break;
		case "Upload":
			
			while (list($key,$val) = each($HTTP_POST_FILES[filerelation][name])){
				if (!empty($val)){
					$no = $key;
					if (upload_file_relation($id,$no)){
						$errmsg .= "File ($no) <b>$val</b> $l[isuploaded].<br>";
					} else {
						$errmsg .= "File ($no) <b>$val</b> $l[isnotuploaded].<br>";
					}
				}
			}
			if (empty($errmsg)) $errmsg = "$l[noupload]";
			
			stdout_error($errmsg);
			
			// update relation in metadata
			metadata_relation_append($id);
			
			break;
		case "Update Description":
			if (is_array($frm[RELATION_NO])){
				while (list($key,$val) = each ($frm[RELATION_NO])){
					if (db_relation_update($id,$val)){
						$errmsg .= "File ($val) $l[isupdated].<br>";
					}
				}
				// update relation in metadata
				metadata_relation_append($id);
			
			} else {
				$errmsg = "$l[noupdate]";
			}
			stdout_error($errmsg);
			break;
		case "Delete":
			if (is_array($frm[RELATION_NO])){
				$finfo = metadata_relation_dbinfo($id);
				while (list($key,$val) = each ($frm[RELATION_NO])){
					if (db_relation_delete($id,$val) && !empty($finfo[RELATION_HASURI][$val]) ){
						if (unlink($finfo[RELATION_HASPATH][$val])){
							$errmsg .= "File ($val) <b>".$finfo[RELATION_HASFILENAME][$val]."</b> $l[isdeleted].<br>";
						} else {
							$errmsg .= "Warning: File ($val) <b>".$finfo[RELATION_HASFILENAME][$val]."</b> $l[isnotdeleted].<br>";
						}
					} else {
						$errmsg .= "Warning: File ($val) $l[isnotdeleted].<br>";
					}
				}
				
				// update relation in metadata
				metadata_relation_append($id);
				
			} else {
				$errmsg = "$l[nodelete]";
			}
			stdout_error($errmsg);
			break;
		default:
			break;
	}
	
}

// upload the files
function upload_file_relation($id,$no)
{
	
	$rinfo = metadata_relation_info($id,$no);
	
	// move file
	if (move_uploaded_file($rinfo[source],$rinfo[haspath])){
		if (db_relation_insert($id,$rinfo)){
			return TRUE;
		} else {
			return FALSE;
		}
	} else {
		return FALSE;
	}
}


%>
      
