<%
/***************************************************************************
                          xmlparser.php  -  function related to xml parsing
                             -------------------
    begin                : June 14, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
if (defined ('xmlparser_php')) { 
	return; 
} else { 
	define ('xmlparser_php', true); 
}

function cleanupXML($xml_data)
{
	$trans_1 = get_html_translation_table(HTML_ENTITIES);
	$trans_2 = get_html_translation_table(HTML_SPECIALCHARS);
	$trans = array_diff($trans_1,$trans_2);
	$trans = array_flip($trans);

	$data = strtr($xml_data,$trans);
	
	return $data;
}

function readXML($xmldata) {
	
	$xmldata = cleanupXML($xmldata);
	$xsize = strlen($xmldata);
	
	//echo $xmldata;
	
	$xmldata = stripslashes($xmldata);
	$parser = xml_parser_create();
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_parse_into_struct($parser,$xmldata,&$values,&$tags);
	xml_parser_free($parser);

	foreach ($tags as $key=>$val) {
		$root++;
		//echo "<br>$key---->$val\n";
		if ($root == 1){
			$molranges = $val;
			for ($i=0; $i < count($molranges); $i+=2) {
			    $offset = $molranges[$i] + 1;
				$len = $molranges[$i + 1] - $offset;
				$pmv = array_slice($values, $offset, $len);
				$xml = parseMol($pmv);
			}
		} else {
			//echo "<pre>"; print_r($xml);
			return $xml;
		}
		$root = FALSE;
	}
}

//

function generateTags($tags)
{
	reset($tags);
	
	//print_r($tags);
	
	while(list($key,$val) = each($tags)){
		if (empty($tag))
			$tag_path = $val;
		else
			$tag_path .= ".$val";
	}
	return $tag_path;
}

function parseMol($mvalues) {
	//print_r($mvalues);
	
	for ($j=0; $j < count($mvalues); $j++) {
		// reset
		unset($value);
		// get the arrays
		$tag = strtoupper($mvalues[$j]["tag"]);
		$type = $mvalues[$j]["type"];
		$level = $mvalues[$j]["level"];
		$value = $mvalues[$j]["value"];
		$attributes = $mvalues[$j]["attributes"];

		switch($type){
			case "complete":
				
				if ($level > 2){
					$mytag = generateTags($tags).".$tag";
				} else {
					$mytag = $tag;
				}
				
				// is attributes exist
				if (is_array($attributes)){
					while (list($key,$val) = each($attributes)){
						$xml["$mytag.$key"][] = $val;
					}
				}
				
				// is value exists
				if (!empty($value)){
					$xml[$mytag][] = $value;
				}
				break;
			case "open":
				$tags[$level] = $tag;
				break;
			case "close":
				array_pop($tags);
				break;
		}
	}

	return $xml;
}

// Function to open XML file
function xml_open($xmlfile){
	
	$xmldata = join('',file($xmlfile));
	$xdata = readXML($xmldata);
		
	return $xdata;
}

%>