<%
/***************************************************************************
                          mod_user.inc -  module user administration
                             -------------------
    begin                : June 21, 2002
    copyright            : (C) 2002 Ismail Fahmi, KMRG ITB
    email                : ismail@itb.ac.id

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

$modname = "upload";

require_once "functions/form.php";
require_once "functions/db.php";
require_once "functions/stdout.php";
require_once "functions/explorer.php";
require_once "functions/upload.php";
require_once "functions/image.php";

include "modules/module.conf";

$gid = $mod[gid][$modname];

if (!module_auth($gid,$modname)) {
	return;
};

// show header
upload_header();

// check upload form
if ($form_upload){
		
	$mod_form = "schemas/forms/form_upload_".$type.".inc";
	$mod_validation_file = "schemas/forms/form_upload_".$type."_validate.inc";
			
	if (file_exists($mod_validation_file)){

		// Check the form 
		if (form_is_valid($frm,$mod_validation_file)){
			
			// insert into database
			
			if(upload_metadata()){
				echo "<p>Success $form_action metadata.</p>";
			} else {
				echo "<p>Failed to insert metadata.</p>";
			}
			
		} 

	} else {
		$errmsg = "Error: File <b>$mod_validation_file</b> $e[notfound]";
	}
}

switch ($step){
	case "1":
		include "schemas/forms/form_upload_selection.inc";
		break;
	case "2":

		echo "<p><b>$l[upload_step2]</b></p>";
		
	
		if (empty($type)){
			if (empty($id)){
				stdout_error("Error: $e[nodocument_type]");
			} else {
				$meta_info = metadata_info($id);
				$type = $meta_info[SCHEMA];
			}
			return;
		}
		
		if (!empty($id) && empty($errmsg)){
			if (explorer_folder_iswrite("metadata",$id)){
				$frm = metadata_read_db($id);
				$form_action = "UPDATE";
				//if ($frm == 0) return;
			} else {
				stdout_error($e[access_denied]);
				break;
			}
		}
		
		// insert
		
		// show form
		
		$form_file = "schemas/forms/form_upload_$type.inc";
	
		if (file_exists($form_file)){
			include $form_file;
		} else {
			stdout_error("Error: File <b>$form_file</b> $e[notfound]");
		}

		break;
	
	case "3":
		echo "<p><b>$l[upload_step3]</b></p>";
		
		if (empty($id)){
			stdout_error("Error: $e[nodocument_id]");
			return;
		} else {
			if (explorer_folder_iswrite("metadata",$id)){
				
				if ($form_upload){
					upload_file();
				}
				
				include "forms/form_upload_file.inc";
			} else {
				stdout_error($e[access_denied]);
				return;
			}
		}
		
		break;
		
	default:
		include "schemas/forms/form_upload_selection.inc";
		break;
}
		
%>